package edu.uoc.tfc.web.tags;



import java.util.StringTokenizer;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;

import org.apache.commons.lang.StringUtils;



public class DataTablesTag extends EmktBaseTag {


 
    private static final long serialVersionUID = 1L;



//    private static final Logger LOG = Logger.getLogger(DataTablesTag.class);



    private String tableName;
    private String columnNames;
    private String columnWidths;
    private String columnAttributes;
    private String columnTypes;
    private String parametrosDefecto;
    private String action;
    private boolean footer;
    private boolean searchOnLoad;
    private boolean bytoken = true;
    private boolean multipleselection = false;


    public String getParametrosDefecto() {
		return parametrosDefecto;
	}

	public void setParametrosDefecto(String parametrosDefecto) {
		this.parametrosDefecto = parametrosDefecto;
	}



	public String getColumnAttributes() {
		return columnAttributes;
	}

	public void setColumnAttributes(String columnAttributes) {
		this.columnAttributes = columnAttributes;
	}



	public String getColumnTypes() {
		return columnTypes;
	}

	public void setColumnTypes(String columnTypes) {
		this.columnTypes = columnTypes;
	}



    public Boolean getSearchOnLoad() {
		return searchOnLoad;
	}

	public void setSearchOnLoad(Boolean searchOnLoad) {
		this.searchOnLoad = searchOnLoad;
	}



	public Boolean getFooter() {
		return footer;
	}

	public void setFooter(Boolean footer) {
		this.footer = footer;
	}



	public String getTableName() {
		return tableName;
	}

	public void setTableName(String tableName) {
		this.tableName = tableName;
	}



	public String getAction() {
		return action;
	}

	public void setAction(String action) {
		this.action = action;
	}



	public String getColumnNames() {
		return columnNames;
	}

	public void setColumnNames(String columnNames) {
		this.columnNames = columnNames;
	}

	

	public String getColumnWidths() {
		return columnWidths;
	}

	public void setColumnWidths(String columnWidths) {
		this.columnWidths = columnWidths;
	}

	/**
     * Returns pageContext.
     *
     * @return pageContext
     */
    public PageContext getPageContext() {
        return this.pageContext;
    }

    /**
     * Setear el contexto de la pagina.
     *
     * @param pageContext el contexto de la pagina.
     * @see javax.servlet.jsp.tagext.Tag#setPageContext(javax.servlet.jsp.PageContext)
     */
    public void setPageContext(PageContext pageContext) {
        this.pageContext = pageContext;
    }

    

	public boolean getBytoken() {
		return bytoken;
	}

	public void setBytoken(boolean bytoken) {
		this.bytoken = bytoken;
	}

	public boolean getMultipleselection() {
		return multipleselection;
	}

	public void setMultipleselection(boolean multipleselection) {
		this.multipleselection = multipleselection;
	}

	@Override
	public int doStartTag() throws JspException
	{
		try {
			JspWriter out = this.getPageContext().getOut();
			
			this.writeTable(out);
		} catch (Exception ex) {
			throw new JspException(ex);
		}
		
		return EVAL_BODY_INCLUDE;
	}



    private void writeTable(JspWriter out) throws Exception
    {
    	this.write(out,"<a name=\"ancla\"></a>");
    	this.write(out,"<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" " +
    			"class=\"dataTables_wrapper bordered-table zebra-striped ");    			
    	if(getMultipleselection()){
    		this.write(out,"multiple \"");
    	}else{
    		this.write(out,"single \"");
    	}
		this.write(out,"role=\"grid\" id=\"" + this.getTableName() + "\">");
    	this.write(out,"<thead>");
    	this.write(out,"<tr>");
    	
    	this.writeColumnHeaders(out);
    	
    	this.write(out,"</tr>");
    	this.write(out,"</thead>");
    	
    	this.writeBlankRows(out);
    	
    	if (this.getFooter()) {
    		
    		StringTokenizer st = new StringTokenizer(this.getColumnNames(), ",");
        	
	    	this.write(out,"<tfoot class=\"datatable-tfoot\">");
	    	this.write(out,"<tr>");
	    	this.write(out,"<th colspan=\"" + st.countTokens() + "\" rowspan=\"1\">");
    	}
	}



    private void writeBlankRows(JspWriter out) throws Exception
    {
    	StringTokenizer st = new StringTokenizer(this.getColumnNames(), ",");
    	
    	int rows = 0;
    	int columns = st.countTokens();
    	
    	this.write(out,"<tbody class=\"selectable\">");
    	for (int i = 0; i < rows; i++) {
    		this.write(out,"<tr class=\"odd gradeX\">");
    		for (int j = 0; j < columns; j++) {	
    			this.write(out,"<td>&nbsp;</td>");
    		}
    		this.write(out,"</tr>");
		}
    	this.write(out,"</tbody>");
    	
	}



	/**
     * <th>Rendering engine</th>
     * @param out
     */
	private void writeColumnHeaders(JspWriter out) throws Exception
	{
		StringTokenizer st = new StringTokenizer(this.getColumnNames(), ",");
		StringTokenizer stw = new StringTokenizer(this.getColumnWidths(), ",");
    	while (st.hasMoreTokens()) {
    		String column = st.nextToken();
    		String sWidth = stw.nextToken();
    		this.write(out,"<th width=\"" + sWidth + "%\">" + this.getMessage(column.trim(), null) + "</th>");
    	}
	}



	private void writeJavascript(JspWriter out) throws Exception
	{
    	this.write(out, "<script>");
    	
    	// Init
    	if (this.isModal()) {
    		this.write(out, "oTableModal = null;");
    	} else {
    		this.write(out, "oTable = null;");
    	}

    	this.write(out, "function " + this.getTableName() + "() { ");
		this.write(out, " var tableName = '" + this.getTableName() + "';");

		if (StringUtils.isNotBlank(getAction()))
		{
			this.write(out, " var action = '" + this.getContextPath() + this.getAction() + "';");
		}
		else
		{
			this.write(out, " var action = undefined;");
		}

		this.write(out," var columns = " + this.getColumns().trim() + ";");
		this.write(out," var bytoken = " + this.getBytoken() + ";");
		this.write(out," var columnDefs = " +this.getColumnDefs() + ";");
		this.write(out," buscarDelegate(getTable(), tableName, action, columns, columnDefs, bytoken);");

		this.write(out,"}");

    	if (this.getSearchOnLoad())
    	{
    		this.write(out, "$(document).ready(function() {");
    		this.write(out, "  " + this.getTableName() + "();");
    		this.write(out, "} )");
    	}

// 		Para la versin de DataTableButtonTag con tooltip
//    	this.write(out,"$(\"#" + this.getTableName() + "\").tooltip({selector: \"button[rel=tooltip]\"});");

		this.write(out,"</script>");
	}



	private String getColumnDefs()
	{
		StringBuffer sb = new StringBuffer();
    	sb.append("[");
    	if (this.getColumnTypes() != null)
    	{
	    	boolean first = true;
	    	int index = 0;
	    	StringTokenizer st = new StringTokenizer(this.getColumnTypes(), ",");
	    	while (st.hasMoreTokens())
	    	{
	    		String type = st.nextToken().trim();
	    		if (
	    			StringUtils.isNotBlank(type) &&
	    			!StringUtils.equals("String", type)
	    		){
	    			if (!first)
	    			{
	    				sb.append(",");
	    			}
		    		sb.append("{");
		    		sb.append("\"bUseRendered\": false");
		    		sb.append(",\"fnRender\": render" + type);
		    		sb.append(",\"aTargets\":[" + index + "]");
		    		sb.append("}");
		    		first = false;
	    		}
	    		index++;
	    	}
    	}
    	sb.append("]");
    	return sb.toString();
    }



	private String getColumns() throws Exception
	{
    	StringBuffer sb = new StringBuffer();
    	StringTokenizer st = new StringTokenizer(this.getColumnAttributes(), ",");

    	sb.append("[");

    	while (st.hasMoreTokens())
    	{
    		String column = st.nextToken();
    		sb.append("{ \"mDataProp\": \"" + column.trim() + "\" }");
    		if (st.hasMoreTokens())
    		{
    			sb.append(",");
    		}
    	}

    	sb.append("]");
    	return sb.toString();
	}



	public int doEndTag() throws JspException
	{
		try
		{
			JspWriter out = this.getPageContext().getOut();
			
			if (this.getFooter())
			{
				this.write(out,"</th>");
		    	this.write(out,"</tr>");
		    	this.write(out,"</tfoot>");
	    	}

	    	this.write(out,"</table>");

	    	this.writeJavascript(out);
		}
		catch (Exception ex)
		{
			throw new JspException(ex);			
		}

        return EVAL_PAGE;
    }



}
