package edu.uoc.tfc.web.tags;



import java.lang.reflect.Method;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.Tag;

import org.apache.commons.lang.StringUtils;
import org.apache.struts.Globals;
import org.apache.struts.taglib.TagUtils;
import org.apache.struts.taglib.html.BaseFieldTag;



public abstract class EmktBaseTag extends BaseFieldTag implements Tag
{



	private static final long serialVersionUID = 1L;



	/**
	 * Profundidad mxima que se utilizar a la hora de buscar el contenedor
	 * padre de una tag (el TabContainer de un Tab, el Form de Field,...).
	 */
	public static final int MAX_DEEP = 5;



	private Boolean modal;
    private Boolean required = false;
    private boolean readonly = false;
	private boolean prettyWrite = true;



	public Boolean isRequired() {
		return required;
	}

	public void setRequired(Boolean required) {
		this.required = required;
	}



	public Boolean isModal() {
		modal = StringUtils.equals("true", pageContext.getRequest().getParameter("modal"));
		return modal;
	}

	public void setModal(Boolean modal) {
		this.modal = modal;
	}



    public boolean isPrettyWrite() {
		return prettyWrite;
	}

	public void setPrettyWrite(boolean prettyWrite) {
		this.prettyWrite = prettyWrite;
	}



	public boolean isReadonly()
	{
		boolean result = this.readonly;
		if (!result)
		{
			result = (StringUtils.equals("true", (String) pageContext.getRequest().getAttribute("readonly")));
		}
		return result;
	}



	public void setReadonly(boolean readonly) {
		this.readonly = readonly;
	}



	protected void write(JspWriter out, String data) throws Exception {
    	out.write(data);
    	if (this.isPrettyWrite()) {
    		out.write("\r\n");
    	}
    }



    protected String getContextPath() {
    	HttpServletRequest request = (HttpServletRequest) pageContext.getRequest();
    	
		  String path = request.getContextPath();
		  
		  String getProtocol=request.getScheme();
		  String getDomain=request.getServerName();
		  String getPort=Integer.toString(request.getServerPort());
		  
		  return getProtocol+"://"+getDomain+":"+getPort+path+"/";
	}



    protected String getMessage(String key, String[] args) throws Exception {
		String message = 
		 	TagUtils.getInstance().message(
				 pageContext, 
				 getBundle(), 
				 Globals.LOCALE_KEY, 
				 key, 
				 args
		 	);
		return message;
    }



	protected String escapeNameForJqueryId(String name)
	{
		return StringUtils.replaceChars(name, ".", "-");
    }



	protected String escapeNameForJsFunction(String name)
	{
		return
			StringUtils.remove(
				StringUtils.remove(
					StringUtils.capitalize(name),
					"."
				),
				"-"
			);
    }
	
	protected final Object getFormBean()
	{
		BaseFormBeanParser formBeanParser = (BaseFormBeanParser)
			new StrutsFormBeanParser();

		Object formBean =
			formBeanParser.parseFormBean(
				(HttpServletRequest) pageContext.getRequest()
			);

		return formBean;
	}



	protected final Object parseaObjeto(Object formBean) throws Exception
	{
		Method[] metodos = formBean.getClass().getMethods();
		Method getter = null;

		for (int i = 0; i < metodos.length; i++)
		{
			if (metodos[i].getName().equalsIgnoreCase("get" + this.getProperty()))
			{
				getter = metodos[i];
			}
		}

		Object returnValue = getter.invoke(formBean, new Object[]{});
		return returnValue;
	}	



}
