package edu.uoc.tfc.web.tags;



import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.Tag;

import org.apache.commons.lang.StringUtils;



public class SelectOptionTag extends EmktBaseTag 
{



    private static final long serialVersionUID = 1L;
    private String label;
    private String value;
    private boolean checked = false;
	private SelectFieldTag selectTag;
	private boolean resolveLabel = true;



    public String getLabel() {
    	return label;
    }

	public void setLabel(String label) {
    	this.label = label;
    }



	public String getValue() {
    	return value;
    }

	public void setValue(String value) {
    	this.value = value;
    }



	public boolean isChecked() {
    	return checked;
    }

	public void setChecked(boolean checked) {
    	this.checked = checked;
    }



	public SelectFieldTag getSelectTag() {
	    return selectTag;
    }

	public void setSelectTag(SelectFieldTag selectTag) {
	    this.selectTag = selectTag;
    }



	public boolean isResolveLabel() {
    	return resolveLabel;
    }

	public void setResolveLabel(boolean resolveLabel) {
    	this.resolveLabel = resolveLabel;
    }



	@Override
	public int doStartTag() throws JspException
	{
		initializeSelectOptionTag();

		if (!getSelectTag().readonly())
		{
			try
			{
				JspWriter out = pageContext.getOut();
				write(out,"<option value=\"" + getValue() + "\"");

			    if (
			    	isChecked() ||
			    	(
			    		getParent() instanceof SelectFieldTag &&
			    		StringUtils.equals(((SelectFieldTag) getParent()).getValue(), getValue())
			    	)
			    ){
			    	write(out," selected=\"selected\"");
			    }

			    String processedLabel;
			    if (isResolveLabel())
			    {
			    	processedLabel = getMessage(getLabel(), null);
			    }
			    else
			    {
			    	processedLabel = getLabel();
			    }

			    write(out,">" + processedLabel + "</option>");
			}
			catch (Exception ex)
			{
				String message = "Error generando Opciones de Desplegable: " + this.getProperty();
				throw new JspException(message);
			}
		}

		return SKIP_BODY;
	}



	protected void initializeSelectOptionTag()
	{
		Tag parentTag = this;
		boolean found = false;
		int counter = 0;
		do
		{
			parentTag = parentTag.getParent();
			found = parentTag instanceof SelectFieldTag;
		}
		while ((!found && counter++ < EmktBaseTag.MAX_DEEP && parentTag != null));

	    if (found)
	    {
			setSelectTag((SelectFieldTag) parentTag);
			SelectOptionTag newOptionTag = new SelectOptionTag();
			newOptionTag.setValue(getValue());
			newOptionTag.setLabel(getLabel());
			newOptionTag.setSelectTag(getSelectTag());
			newOptionTag.setChecked(isChecked());
			getSelectTag().getOptions().add(newOptionTag);
	    }
	    else
	    {
			String message = "El elemento SelectOptionTag no est dentro de un SelectFieldTag.";
	    }
	}



}
