// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: SpringServiceLocator.vsl in andromda-spring-cartridge.
//
package edu.uoc.tfc;

/**
 * Locates and provides all available application services.
 */
public class ServiceLocator
{

    private ServiceLocator()
    {
        // shouldn't be instantiated
    }

    /**
     * The prefix used for all bean ids.
     */
    public static final String BEAN_PREFIX = "";

    /**
     * The shared instance of this ServiceLocator.
     */
    private final static ServiceLocator instance = new ServiceLocator();

    /**
     * Gets the shared instance of this Class
     *
     * @return the shared service locator instance.
     */
    public static final ServiceLocator instance()
    {
        return instance;
    }

    /**
     * The bean factory reference instance.
     */
    private org.springframework.beans.factory.access.BeanFactoryReference beanFactoryReference;

    /**
     * The bean factory reference location.
     */
    private String beanFactoryReferenceLocation;

    /**
     * The bean factory reference id.
     */
    private String beanRefFactoryReferenceId;

    /**
     * Initializes the Spring application context from
     * the given <code>beanFactoryReferenceLocation</code>.  If <code>null</code>
     * is specified for the <code>beanFactoryReferenceLocation</code>
     * then the default application context will be used.
     *
     * @param beanFactoryReferenceLocation the location of the beanRefFactory reference.
     */
    public synchronized void init(final String beanFactoryReferenceLocation, final String beanRefFactoryReferenceId)
    {
        this.beanFactoryReferenceLocation = beanFactoryReferenceLocation;
        this.beanRefFactoryReferenceId = beanRefFactoryReferenceId;
        this.beanFactoryReference = null;
    }

    /**
     * Initializes the Spring application context from
     * the given <code>beanFactoryReferenceLocation</code>.  If <code>null</code>
     * is specified for the <code>beanFactoryReferenceLocation</code>
     * then the default application context will be used.
     *
     * @param beanFactoryReferenceLocation the location of the beanRefFactory reference.
     */
    public synchronized void init(final String beanFactoryReferenceLocation)
    {
        this.beanFactoryReferenceLocation = beanFactoryReferenceLocation;
        this.beanFactoryReference = null;
    }

    /**
     * The default bean reference factory location.
     */
    private final String DEFAULT_BEAN_REFERENCE_LOCATION = "beanRefFactory.xml";

    /**
     * The default bean reference factory ID.
     */
    private final String DEFAULT_BEAN_REFERENCE_ID = "beanRefFactory";

    /**
     * Gets the Spring ApplicationContext.
     */
    public synchronized org.springframework.context.ApplicationContext getContext()
    {
        if (this.beanFactoryReference == null)
        {
            if (this.beanFactoryReferenceLocation == null)
            {
                this.beanFactoryReferenceLocation = DEFAULT_BEAN_REFERENCE_LOCATION;
            }
            if (this.beanRefFactoryReferenceId == null)
            {
                this.beanRefFactoryReferenceId = DEFAULT_BEAN_REFERENCE_ID;
            }
            org.springframework.beans.factory.access.BeanFactoryLocator beanFactoryLocator =
                org.springframework.context.access.ContextSingletonBeanFactoryLocator.getInstance(
                    this.beanFactoryReferenceLocation);
            this.beanFactoryReference = beanFactoryLocator.useBeanFactory(this.beanRefFactoryReferenceId);
        }
        return (org.springframework.context.ApplicationContext)this.beanFactoryReference.getFactory();
    }

    /**
     * Shuts down the ServiceLocator and releases any used resources.
     */
    public synchronized void shutdown()
    {
        ((org.springframework.context.support.AbstractApplicationContext)this.getContext()).close();
        if (this.beanFactoryReference != null)
        {
            this.beanFactoryReference.release();
            this.beanFactoryReference = null;
        }
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.service.security.SecurityService}.
     */
    public final edu.uoc.tfc.service.security.SecurityService getSecurityService()
    {
        return (edu.uoc.tfc.service.security.SecurityService)
            getContext().getBean("securityService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.service.AsseguradoraService}.
     */
    public final edu.uoc.tfc.service.AsseguradoraService getAsseguradoraService()
    {
        return (edu.uoc.tfc.service.AsseguradoraService)
            getContext().getBean("asseguradoraService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.service.ClientService}.
     */
    public final edu.uoc.tfc.service.ClientService getClientService()
    {
        return (edu.uoc.tfc.service.ClientService)
            getContext().getBean("clientService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.service.PartService}.
     */
    public final edu.uoc.tfc.service.PartService getPartService()
    {
        return (edu.uoc.tfc.service.PartService)
            getContext().getBean("partService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.service.TipusSinistreService}.
     */
    public final edu.uoc.tfc.service.TipusSinistreService getTipusSinistreService()
    {
        return (edu.uoc.tfc.service.TipusSinistreService)
            getContext().getBean("tipusSinistreService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.dbmodel.security.crud.UserManageableService}.
     */
    public final edu.uoc.tfc.dbmodel.security.crud.UserManageableService getUserManageableService()
    {
        return (edu.uoc.tfc.dbmodel.security.crud.UserManageableService)
            getContext().getBean("UserManageableService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.dbmodel.security.crud.RoleManageableService}.
     */
    public final edu.uoc.tfc.dbmodel.security.crud.RoleManageableService getRoleManageableService()
    {
        return (edu.uoc.tfc.dbmodel.security.crud.RoleManageableService)
            getContext().getBean("RoleManageableService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.dbmodel.security.crud.OperationManageableService}.
     */
    public final edu.uoc.tfc.dbmodel.security.crud.OperationManageableService getOperationManageableService()
    {
        return (edu.uoc.tfc.dbmodel.security.crud.OperationManageableService)
            getContext().getBean("OperationManageableService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.dbmodel.crud.PartManageableService}.
     */
    public final edu.uoc.tfc.dbmodel.crud.PartManageableService getPartManageableService()
    {
        return (edu.uoc.tfc.dbmodel.crud.PartManageableService)
            getContext().getBean("PartManageableService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.dbmodel.crud.FacturaManageableService}.
     */
    public final edu.uoc.tfc.dbmodel.crud.FacturaManageableService getFacturaManageableService()
    {
        return (edu.uoc.tfc.dbmodel.crud.FacturaManageableService)
            getContext().getBean("FacturaManageableService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.dbmodel.crud.TipusSiniestreManageableService}.
     */
    public final edu.uoc.tfc.dbmodel.crud.TipusSiniestreManageableService getTipusSiniestreManageableService()
    {
        return (edu.uoc.tfc.dbmodel.crud.TipusSiniestreManageableService)
            getContext().getBean("TipusSiniestreManageableService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService}.
     */
    public final edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService getAsseguradoraManageableService()
    {
        return (edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService)
            getContext().getBean("AsseguradoraManageableService");
    }

    /**
     * Gets an instance of {@link edu.uoc.tfc.dbmodel.crud.ClientManageableService}.
     */
    public final edu.uoc.tfc.dbmodel.crud.ClientManageableService getClientManageableService()
    {
        return (edu.uoc.tfc.dbmodel.crud.ClientManageableService)
            getContext().getBean("ClientManageableService");
    }


    /**
     * Gets an instance of the given service.
     */
    public final Object getService(String serviceName)
    {
        return getContext().getBean(BEAN_PREFIX + serviceName);
    }

}