// license-header java merge-point
package edu.uoc.tfc.dbmodel.crud;

import org.hibernate.Session;
import org.hibernate.Criteria;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Expression;

public final class AsseguradoraManageableDaoBase
    extends org.springframework.orm.hibernate3.support.HibernateDaoSupport
    implements AsseguradoraManageableDao
{
    private edu.uoc.tfc.dbmodel.AsseguradoraDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.AsseguradoraDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.AsseguradoraDao getDao()
    {
        return this.dao;
    }

    private edu.uoc.tfc.dbmodel.PartDao partsDao = null;

    public void setPartsDao(edu.uoc.tfc.dbmodel.PartDao partsDao)
    {
        this.partsDao = partsDao;
    }

    protected edu.uoc.tfc.dbmodel.PartDao getPartsDao()
    {
        return this.partsDao;
    }

    private java.util.Set findPartByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.PartImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public edu.uoc.tfc.dbmodel.Asseguradora create(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts)
    {
        final edu.uoc.tfc.dbmodel.Asseguradora entity = new edu.uoc.tfc.dbmodel.AsseguradoraImpl();
        entity.setNom(nom);
        entity.setDescripcio(descripcio);
        entity.setActiva(activa);
        entity.setId(id);
        final java.util.Set partsEntities = (parts != null && parts.length > 0)
            ? this.findPartByIds(parts)
            : java.util.Collections.EMPTY_SET;

        entity.setParts(partsEntities);


        return (edu.uoc.tfc.dbmodel.Asseguradora)this.getDao().create(entity);
    }

    public edu.uoc.tfc.dbmodel.Asseguradora readById(java.lang.Long id)
    {
        return getDao().load(id);
    }

    public java.util.List read(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.AsseguradoraImpl.class);

            if (nom != null)
                criteria.add(Expression.ilike("nom", nom, MatchMode.START));
            if (descripcio != null)
                criteria.add(Expression.ilike("descripcio", descripcio, MatchMode.START));
            if (activa != null)
            if (activa.booleanValue()) criteria.add(Expression.eq("activa", java.lang.Boolean.TRUE));
            if (id != null)
            criteria.add(Expression.eq("id", id));
            if (parts != null && parts.length > 0) criteria.createCriteria("parts").add(Expression.in("id", parts));
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.List readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.AsseguradoraImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.Map readBackingLists()
    {
        final java.util.Map lists = new java.util.HashMap();
        final Session session = this.getSession();

        try
        {
            lists.put("parts", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.Part item order by item.id").list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    public edu.uoc.tfc.dbmodel.Asseguradora update(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts)
    {
        final edu.uoc.tfc.dbmodel.Asseguradora entity = this.getDao().load(id);

        entity.setNom(nom);
        entity.setDescripcio(descripcio);
        entity.setActiva(activa);
        final java.util.Set partsEntities = (parts != null && parts.length > 0)
            ? this.findPartByIds(parts)
            : java.util.Collections.EMPTY_SET;

        entity.setParts(partsEntities);


        this.getDao().update(entity);
        return entity;
    }

    public void delete(java.lang.Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final org.hibernate.Query queryObject =
                session.createQuery("delete edu.uoc.tfc.dbmodel.AsseguradoraImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

}