// license-header java merge-point
package edu.uoc.tfc.dbmodel.crud;

public final class AsseguradoraManageableServiceBase
    implements AsseguradoraManageableService
{
    private edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableDao getDao()
    {
        return this.dao;
    }

    public edu.uoc.tfc.dbmodel.crud.AsseguradoraValueObject create(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts)
        throws Exception
    {
        if (nom == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService.create(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts) - 'nom' can not be null");
        }

        if (descripcio == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService.create(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts) - 'descripcio' can not be null");
        }

        if (activa == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService.create(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts) - 'activa' can not be null");
        }

        return toValueObject(dao.create(nom, descripcio, activa, id, parts));
    }

    public edu.uoc.tfc.dbmodel.crud.AsseguradoraValueObject readById(java.lang.Long id)
        throws Exception
    {
        return toValueObject(dao.readById(id));
    }

    public java.util.List read(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts)
        throws Exception
    {
        return toValueObjects(dao.read(nom, descripcio, activa, id, parts));
    }

    public java.util.List readAll()
        throws Exception
    {
        return toValueObjects(dao.readAll());
    }

    public java.util.Map readBackingLists()
        throws Exception
    {
        return getDao().readBackingLists();
    }

    public edu.uoc.tfc.dbmodel.crud.AsseguradoraValueObject update(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts)
        throws Exception
    {
        if (nom == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService.update(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts) - 'nom' can not be null");
        }

        if (descripcio == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService.update(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts) - 'descripcio' can not be null");
        }

        if (activa == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService.update(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts) - 'activa' can not be null");
        }

        if (id == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService.update(java.lang.String nom, java.lang.String descripcio, java.lang.Boolean activa, java.lang.Long id, java.lang.Long[] parts) - 'id' can not be null");
        }

        return toValueObject(dao.update(nom, descripcio, activa, id, parts));
    }

    public void delete(java.lang.Long[] ids)
        throws Exception
    {
        if (ids == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.AsseguradoraManageableService.delete(java.lang.Long[] ids) - 'ids' can not be null");
        }

        dao.delete(ids);
    }


    private static java.util.List toValueObjects(java.util.Collection entities)
    {
        final java.util.List list = new java.util.ArrayList();

        for (java.util.Iterator iterator = entities.iterator(); iterator.hasNext();)
        {
            list.add(toValueObject((edu.uoc.tfc.dbmodel.Asseguradora)iterator.next()));
        }

        return list;
    }

    private static edu.uoc.tfc.dbmodel.crud.AsseguradoraValueObject toValueObject(edu.uoc.tfc.dbmodel.Asseguradora entity)
    {
        final edu.uoc.tfc.dbmodel.crud.AsseguradoraValueObject valueObject = new edu.uoc.tfc.dbmodel.crud.AsseguradoraValueObject();

        valueObject.setNom(entity.getNom());
        valueObject.setDescripcio(entity.getDescripcio());
        valueObject.setActiva(entity.getActiva());
        valueObject.setId(entity.getId());

        final java.util.Collection parts = entity.getParts();
        if (parts == null || parts.isEmpty())
        {
            valueObject.setParts(null);
        }
        else
        {
            final java.lang.Long[] values = new java.lang.Long[parts.size()];
            int counter = 0;
            for (final java.util.Iterator iterator = parts.iterator(); iterator.hasNext();counter++)
            {
                final edu.uoc.tfc.dbmodel.Part element = (edu.uoc.tfc.dbmodel.Part)iterator.next();
                values[counter] = element.getId();
            }
            valueObject.setParts(values);
        }

        return valueObject;
    }
}
