// license-header java merge-point
package edu.uoc.tfc.dbmodel.crud;

import org.hibernate.Session;
import org.hibernate.Criteria;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Expression;

public final class ClientManageableDaoBase
    extends org.springframework.orm.hibernate3.support.HibernateDaoSupport
    implements ClientManageableDao
{
    private edu.uoc.tfc.dbmodel.ClientDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.ClientDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.ClientDao getDao()
    {
        return this.dao;
    }

    private edu.uoc.tfc.dbmodel.PartDao partsDelClientDao = null;

    public void setPartsDelClientDao(edu.uoc.tfc.dbmodel.PartDao partsDelClientDao)
    {
        this.partsDelClientDao = partsDelClientDao;
    }

    protected edu.uoc.tfc.dbmodel.PartDao getPartsDelClientDao()
    {
        return this.partsDelClientDao;
    }

    private java.util.Set findPartByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.PartImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public edu.uoc.tfc.dbmodel.Client create(java.lang.String dni, java.lang.String nom, java.lang.String primerCognom, java.lang.String segonCognom, java.lang.String telefon, java.lang.String mail, java.lang.String dataNaixement, java.lang.Boolean actiu, java.lang.Long id, java.lang.Long[] partsDelClient)
    {
        final edu.uoc.tfc.dbmodel.Client entity = new edu.uoc.tfc.dbmodel.ClientImpl();
        entity.setDni(dni);
        entity.setNom(nom);
        entity.setPrimerCognom(primerCognom);
        entity.setSegonCognom(segonCognom);
        entity.setTelefon(telefon);
        entity.setMail(mail);
        entity.setDataNaixement(dataNaixement);
        entity.setActiu(actiu);
        entity.setId(id);
        final java.util.Set partsDelClientEntities = (partsDelClient != null && partsDelClient.length > 0)
            ? this.findPartByIds(partsDelClient)
            : java.util.Collections.EMPTY_SET;

        entity.setPartsDelClient(partsDelClientEntities);


        return (edu.uoc.tfc.dbmodel.Client)this.getDao().create(entity);
    }

    public edu.uoc.tfc.dbmodel.Client readById(java.lang.Long id)
    {
        return getDao().load(id);
    }

    public java.util.List read(java.lang.String dni, java.lang.String nom, java.lang.String primerCognom, java.lang.String segonCognom, java.lang.String telefon, java.lang.String mail, java.lang.String dataNaixement, java.lang.Boolean actiu, java.lang.Long id, java.lang.Long[] partsDelClient)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.ClientImpl.class);

            if (dni != null)
                criteria.add(Expression.ilike("dni", dni, MatchMode.START));
            if (nom != null)
                criteria.add(Expression.ilike("nom", nom, MatchMode.START));
            if (primerCognom != null)
                criteria.add(Expression.ilike("primerCognom", primerCognom, MatchMode.START));
            if (segonCognom != null)
                criteria.add(Expression.ilike("segonCognom", segonCognom, MatchMode.START));
            if (telefon != null)
                criteria.add(Expression.ilike("telefon", telefon, MatchMode.START));
            if (mail != null)
                criteria.add(Expression.ilike("mail", mail, MatchMode.START));
            if (dataNaixement != null)
                criteria.add(Expression.ilike("dataNaixement", dataNaixement, MatchMode.START));
            if (actiu != null)
            if (actiu.booleanValue()) criteria.add(Expression.eq("actiu", java.lang.Boolean.TRUE));
            if (id != null)
            criteria.add(Expression.eq("id", id));
            if (partsDelClient != null && partsDelClient.length > 0) criteria.createCriteria("partsDelClient").add(Expression.in("id", partsDelClient));
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.List readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.ClientImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.Map readBackingLists()
    {
        final java.util.Map lists = new java.util.HashMap();
        final Session session = this.getSession();

        try
        {
            lists.put("partsDelClient", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.Part item order by item.id").list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    public edu.uoc.tfc.dbmodel.Client update(java.lang.String dni, java.lang.String nom, java.lang.String primerCognom, java.lang.String segonCognom, java.lang.String telefon, java.lang.String mail, java.lang.String dataNaixement, java.lang.Boolean actiu, java.lang.Long id, java.lang.Long[] partsDelClient)
    {
        final edu.uoc.tfc.dbmodel.Client entity = this.getDao().load(id);

        entity.setDni(dni);
        entity.setNom(nom);
        entity.setPrimerCognom(primerCognom);
        entity.setSegonCognom(segonCognom);
        entity.setTelefon(telefon);
        entity.setMail(mail);
        entity.setDataNaixement(dataNaixement);
        entity.setActiu(actiu);
        final java.util.Set partsDelClientEntities = (partsDelClient != null && partsDelClient.length > 0)
            ? this.findPartByIds(partsDelClient)
            : java.util.Collections.EMPTY_SET;

        entity.setPartsDelClient(partsDelClientEntities);


        this.getDao().update(entity);
        return entity;
    }

    public void delete(java.lang.Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final org.hibernate.Query queryObject =
                session.createQuery("delete edu.uoc.tfc.dbmodel.ClientImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

}