// license-header java merge-point
package edu.uoc.tfc.dbmodel.crud;

import org.hibernate.Session;
import org.hibernate.Criteria;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Expression;

public final class FacturaManageableDaoBase
    extends org.springframework.orm.hibernate3.support.HibernateDaoSupport
    implements FacturaManageableDao
{
    private edu.uoc.tfc.dbmodel.FacturaDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.FacturaDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.FacturaDao getDao()
    {
        return this.dao;
    }

    private edu.uoc.tfc.dbmodel.PartDao partDeLaFacturaDao = null;

    public void setPartDeLaFacturaDao(edu.uoc.tfc.dbmodel.PartDao partDeLaFacturaDao)
    {
        this.partDeLaFacturaDao = partDeLaFacturaDao;
    }

    protected edu.uoc.tfc.dbmodel.PartDao getPartDeLaFacturaDao()
    {
        return this.partDeLaFacturaDao;
    }

    private java.util.Set findPartByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.PartImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public edu.uoc.tfc.dbmodel.Factura create(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura)
    {
        final edu.uoc.tfc.dbmodel.Factura entity = new edu.uoc.tfc.dbmodel.FacturaImpl();
        entity.setCodiFactura(codiFactura);
        entity.setDataEmissio(dataEmissio);
        entity.setId(id);
        edu.uoc.tfc.dbmodel.Part partDeLaFacturaEntity = null;
        if (partDeLaFactura != null)
        {
            partDeLaFacturaEntity = (edu.uoc.tfc.dbmodel.Part)getPartDeLaFacturaDao().load(partDeLaFactura);
        }

        entity.setPartDeLaFactura(partDeLaFacturaEntity);


        return (edu.uoc.tfc.dbmodel.Factura)this.getDao().create(entity);
    }

    public edu.uoc.tfc.dbmodel.Factura readById(java.lang.Long id)
    {
        return getDao().load(id);
    }

    public java.util.List read(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.FacturaImpl.class);

            if (codiFactura != null)
                criteria.add(Expression.ilike("codiFactura", codiFactura, MatchMode.START));
            if (dataEmissio != null)
                criteria.add(Expression.ilike("dataEmissio", dataEmissio, MatchMode.START));
            if (id != null)
            criteria.add(Expression.eq("id", id));
            if (partDeLaFactura != null) criteria.createCriteria("partDeLaFactura").add(Expression.eq("id", partDeLaFactura));
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.List readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.FacturaImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.Map readBackingLists()
    {
        final java.util.Map lists = new java.util.HashMap();
        final Session session = this.getSession();

        try
        {
            lists.put("partDeLaFactura", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.Part item order by item.id").list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    public edu.uoc.tfc.dbmodel.Factura update(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura)
    {
        final edu.uoc.tfc.dbmodel.Factura entity = this.getDao().load(id);

        entity.setCodiFactura(codiFactura);
        entity.setDataEmissio(dataEmissio);
        edu.uoc.tfc.dbmodel.Part partDeLaFacturaEntity = null;
        if (partDeLaFactura != null)
        {
            partDeLaFacturaEntity = getPartDeLaFacturaDao().load(partDeLaFactura);
        }

        entity.setPartDeLaFactura(partDeLaFacturaEntity);


        this.getDao().update(entity);
        return entity;
    }

    public void delete(java.lang.Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final org.hibernate.Query queryObject =
                session.createQuery("delete edu.uoc.tfc.dbmodel.FacturaImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

}