// license-header java merge-point
package edu.uoc.tfc.dbmodel.crud;

public final class FacturaManageableServiceBase
    implements FacturaManageableService
{
    private edu.uoc.tfc.dbmodel.crud.FacturaManageableDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.crud.FacturaManageableDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.crud.FacturaManageableDao getDao()
    {
        return this.dao;
    }

    public edu.uoc.tfc.dbmodel.crud.FacturaValueObject create(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura)
        throws Exception
    {
        if (codiFactura == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.FacturaManageableService.create(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura) - 'codiFactura' can not be null");
        }

        if (dataEmissio == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.FacturaManageableService.create(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura) - 'dataEmissio' can not be null");
        }

        if (partDeLaFactura == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.FacturaManageableService.create(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura) - 'partDeLaFactura' can not be null");
        }

        return toValueObject(dao.create(codiFactura, dataEmissio, id, partDeLaFactura));
    }

    public edu.uoc.tfc.dbmodel.crud.FacturaValueObject readById(java.lang.Long id)
        throws Exception
    {
        return toValueObject(dao.readById(id));
    }

    public java.util.List read(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura)
        throws Exception
    {
        return toValueObjects(dao.read(codiFactura, dataEmissio, id, partDeLaFactura));
    }

    public java.util.List readAll()
        throws Exception
    {
        return toValueObjects(dao.readAll());
    }

    public java.util.Map readBackingLists()
        throws Exception
    {
        return getDao().readBackingLists();
    }

    public edu.uoc.tfc.dbmodel.crud.FacturaValueObject update(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura)
        throws Exception
    {
        if (codiFactura == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.FacturaManageableService.update(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura) - 'codiFactura' can not be null");
        }

        if (dataEmissio == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.FacturaManageableService.update(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura) - 'dataEmissio' can not be null");
        }

        if (id == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.FacturaManageableService.update(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura) - 'id' can not be null");
        }

        if (partDeLaFactura == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.FacturaManageableService.update(java.lang.String codiFactura, java.lang.String dataEmissio, java.lang.Long id, java.lang.Long partDeLaFactura) - 'partDeLaFactura' can not be null");
        }

        return toValueObject(dao.update(codiFactura, dataEmissio, id, partDeLaFactura));
    }

    public void delete(java.lang.Long[] ids)
        throws Exception
    {
        if (ids == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.crud.FacturaManageableService.delete(java.lang.Long[] ids) - 'ids' can not be null");
        }

        dao.delete(ids);
    }


    private static java.util.List toValueObjects(java.util.Collection entities)
    {
        final java.util.List list = new java.util.ArrayList();

        for (java.util.Iterator iterator = entities.iterator(); iterator.hasNext();)
        {
            list.add(toValueObject((edu.uoc.tfc.dbmodel.Factura)iterator.next()));
        }

        return list;
    }

    private static edu.uoc.tfc.dbmodel.crud.FacturaValueObject toValueObject(edu.uoc.tfc.dbmodel.Factura entity)
    {
        final edu.uoc.tfc.dbmodel.crud.FacturaValueObject valueObject = new edu.uoc.tfc.dbmodel.crud.FacturaValueObject();

        valueObject.setCodiFactura(entity.getCodiFactura());
        valueObject.setDataEmissio(entity.getDataEmissio());
        valueObject.setId(entity.getId());

        final edu.uoc.tfc.dbmodel.Part partDeLaFactura = entity.getPartDeLaFactura();
        if (partDeLaFactura != null)
        {
            valueObject.setPartDeLaFactura(partDeLaFactura.getId());
        }

        return valueObject;
    }
}
