// license-header java merge-point
package edu.uoc.tfc.dbmodel.crud;

import org.hibernate.Session;
import org.hibernate.Criteria;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Expression;

public final class PartManageableDaoBase
    extends org.springframework.orm.hibernate3.support.HibernateDaoSupport
    implements PartManageableDao
{
    private edu.uoc.tfc.dbmodel.PartDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.PartDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.PartDao getDao()
    {
        return this.dao;
    }

    private edu.uoc.tfc.dbmodel.TipusSiniestreDao tipusSinistreDao = null;

    public void setTipusSinistreDao(edu.uoc.tfc.dbmodel.TipusSiniestreDao tipusSinistreDao)
    {
        this.tipusSinistreDao = tipusSinistreDao;
    }

    protected edu.uoc.tfc.dbmodel.TipusSiniestreDao getTipusSinistreDao()
    {
        return this.tipusSinistreDao;
    }

    private edu.uoc.tfc.dbmodel.FacturaDao facturaDelPartDao = null;

    public void setFacturaDelPartDao(edu.uoc.tfc.dbmodel.FacturaDao facturaDelPartDao)
    {
        this.facturaDelPartDao = facturaDelPartDao;
    }

    protected edu.uoc.tfc.dbmodel.FacturaDao getFacturaDelPartDao()
    {
        return this.facturaDelPartDao;
    }

    private edu.uoc.tfc.dbmodel.ClientDao clientDao = null;

    public void setClientDao(edu.uoc.tfc.dbmodel.ClientDao clientDao)
    {
        this.clientDao = clientDao;
    }

    protected edu.uoc.tfc.dbmodel.ClientDao getClientDao()
    {
        return this.clientDao;
    }

    private edu.uoc.tfc.dbmodel.AsseguradoraDao asseguradoraDao = null;

    public void setAsseguradoraDao(edu.uoc.tfc.dbmodel.AsseguradoraDao asseguradoraDao)
    {
        this.asseguradoraDao = asseguradoraDao;
    }

    protected edu.uoc.tfc.dbmodel.AsseguradoraDao getAsseguradoraDao()
    {
        return this.asseguradoraDao;
    }

    private java.util.Set findTipusSiniestreByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.TipusSiniestreImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    private java.util.Set findFacturaByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.FacturaImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    private java.util.Set findClientByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.ClientImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    private java.util.Set findAsseguradoraByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.AsseguradoraImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public edu.uoc.tfc.dbmodel.Part create(java.lang.String codiPart, java.lang.String polissa, java.lang.String dataSinistre, java.lang.Double baseImposable, java.lang.Double percentatgeIva, java.lang.String observacions, java.lang.Boolean obert, java.lang.Long id, java.lang.Long tipusSinistre, java.lang.Long[] facturaDelPart, java.lang.Long client, java.lang.Long asseguradora)
    {
        final edu.uoc.tfc.dbmodel.Part entity = new edu.uoc.tfc.dbmodel.PartImpl();
        entity.setCodiPart(codiPart);
        entity.setPolissa(polissa);
        entity.setDataSinistre(dataSinistre);
        entity.setBaseImposable(baseImposable);
        entity.setPercentatgeIva(percentatgeIva);
        entity.setObservacions(observacions);
        entity.setObert(obert);
        entity.setId(id);
        edu.uoc.tfc.dbmodel.TipusSiniestre tipusSinistreEntity = null;
        if (tipusSinistre != null)
        {
            tipusSinistreEntity = (edu.uoc.tfc.dbmodel.TipusSiniestre)getTipusSinistreDao().load(tipusSinistre);
        }

        entity.setTipusSinistre(tipusSinistreEntity);

        final java.util.Set facturaDelPartEntities = (facturaDelPart != null && facturaDelPart.length > 0)
            ? this.findFacturaByIds(facturaDelPart)
            : java.util.Collections.EMPTY_SET;

        entity.setFacturaDelPart(facturaDelPartEntities);

        edu.uoc.tfc.dbmodel.Client clientEntity = null;
        if (client != null)
        {
            clientEntity = (edu.uoc.tfc.dbmodel.Client)getClientDao().load(client);
        }

        entity.setClient(clientEntity);

        edu.uoc.tfc.dbmodel.Asseguradora asseguradoraEntity = null;
        if (asseguradora != null)
        {
            asseguradoraEntity = (edu.uoc.tfc.dbmodel.Asseguradora)getAsseguradoraDao().load(asseguradora);
        }

        entity.setAsseguradora(asseguradoraEntity);


        return (edu.uoc.tfc.dbmodel.Part)this.getDao().create(entity);
    }

    public edu.uoc.tfc.dbmodel.Part readById(java.lang.Long id)
    {
        return getDao().load(id);
    }

    public java.util.List read(java.lang.String codiPart, java.lang.String polissa, java.lang.String dataSinistre, java.lang.Double baseImposable, java.lang.Double percentatgeIva, java.lang.String observacions, java.lang.Boolean obert, java.lang.Long id, java.lang.Long tipusSinistre, java.lang.Long[] facturaDelPart, java.lang.Long client, java.lang.Long asseguradora)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.PartImpl.class);

            if (codiPart != null)
                criteria.add(Expression.ilike("codiPart", codiPart, MatchMode.START));
            if (polissa != null)
                criteria.add(Expression.ilike("polissa", polissa, MatchMode.START));
            if (dataSinistre != null)
                criteria.add(Expression.ilike("dataSinistre", dataSinistre, MatchMode.START));
            if (baseImposable != null)
            criteria.add(Expression.eq("baseImposable", baseImposable));
            if (percentatgeIva != null)
            criteria.add(Expression.eq("percentatgeIva", percentatgeIva));
            if (observacions != null)
                criteria.add(Expression.ilike("observacions", observacions, MatchMode.START));
            if (obert != null)
            if (obert.booleanValue()) criteria.add(Expression.eq("obert", java.lang.Boolean.TRUE));
            if (id != null)
            criteria.add(Expression.eq("id", id));
            if (tipusSinistre != null) criteria.createCriteria("tipusSinistre").add(Expression.eq("id", tipusSinistre));
            if (facturaDelPart != null && facturaDelPart.length > 0) criteria.createCriteria("facturaDelPart").add(Expression.in("id", facturaDelPart));
            if (client != null) criteria.createCriteria("client").add(Expression.eq("id", client));
            if (asseguradora != null) criteria.createCriteria("asseguradora").add(Expression.eq("id", asseguradora));
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.List readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.PartImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.Map readBackingLists()
    {
        final java.util.Map lists = new java.util.HashMap();
        final Session session = this.getSession();

        try
        {
            lists.put("tipusSinistre", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.TipusSiniestre item order by item.id").list());
            lists.put("facturaDelPart", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.Factura item order by item.id").list());
            lists.put("client", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.Client item order by item.id").list());
            lists.put("asseguradora", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.Asseguradora item order by item.id").list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    public edu.uoc.tfc.dbmodel.Part update(java.lang.String codiPart, java.lang.String polissa, java.lang.String dataSinistre, java.lang.Double baseImposable, java.lang.Double percentatgeIva, java.lang.String observacions, java.lang.Boolean obert, java.lang.Long id, java.lang.Long tipusSinistre, java.lang.Long[] facturaDelPart, java.lang.Long client, java.lang.Long asseguradora)
    {
        final edu.uoc.tfc.dbmodel.Part entity = this.getDao().load(id);

        entity.setCodiPart(codiPart);
        entity.setPolissa(polissa);
        entity.setDataSinistre(dataSinistre);
        entity.setBaseImposable(baseImposable);
        entity.setPercentatgeIva(percentatgeIva);
        entity.setObservacions(observacions);
        entity.setObert(obert);
        edu.uoc.tfc.dbmodel.TipusSiniestre tipusSinistreEntity = null;
        if (tipusSinistre != null)
        {
            tipusSinistreEntity = getTipusSinistreDao().load(tipusSinistre);
        }

        entity.setTipusSinistre(tipusSinistreEntity);

        final java.util.Set facturaDelPartEntities = (facturaDelPart != null && facturaDelPart.length > 0)
            ? this.findFacturaByIds(facturaDelPart)
            : java.util.Collections.EMPTY_SET;

        entity.setFacturaDelPart(facturaDelPartEntities);

        edu.uoc.tfc.dbmodel.Client clientEntity = null;
        if (client != null)
        {
            clientEntity = getClientDao().load(client);
        }

        entity.setClient(clientEntity);

        edu.uoc.tfc.dbmodel.Asseguradora asseguradoraEntity = null;
        if (asseguradora != null)
        {
            asseguradoraEntity = getAsseguradoraDao().load(asseguradora);
        }

        entity.setAsseguradora(asseguradoraEntity);


        this.getDao().update(entity);
        return entity;
    }

    public void delete(java.lang.Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final org.hibernate.Query queryObject =
                session.createQuery("delete edu.uoc.tfc.dbmodel.PartImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

}