// license-header java merge-point
package edu.uoc.tfc.dbmodel.security.crud;

import org.hibernate.Session;
import org.hibernate.Criteria;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Expression;

public final class OperationManageableDaoBase
    extends org.springframework.orm.hibernate3.support.HibernateDaoSupport
    implements OperationManageableDao
{
    private edu.uoc.tfc.dbmodel.security.OperationDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.security.OperationDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.security.OperationDao getDao()
    {
        return this.dao;
    }

    private edu.uoc.tfc.dbmodel.security.RoleDao rolesDao = null;

    public void setRolesDao(edu.uoc.tfc.dbmodel.security.RoleDao rolesDao)
    {
        this.rolesDao = rolesDao;
    }

    protected edu.uoc.tfc.dbmodel.security.RoleDao getRolesDao()
    {
        return this.rolesDao;
    }

    private java.util.Set findRoleByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.security.RoleImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public edu.uoc.tfc.dbmodel.security.Operation create(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles)
    {
        final edu.uoc.tfc.dbmodel.security.Operation entity = new edu.uoc.tfc.dbmodel.security.OperationImpl();
        entity.setName(name);
        entity.setDescription(description);
        entity.setUrl(url);
        entity.setParent(parent);
        entity.setOrdre(ordre);
        entity.setId(id);
        final java.util.Set rolesEntities = (roles != null && roles.length > 0)
            ? this.findRoleByIds(roles)
            : java.util.Collections.EMPTY_SET;

        entity.setRoles(rolesEntities);


        return (edu.uoc.tfc.dbmodel.security.Operation)this.getDao().create(entity);
    }

    public edu.uoc.tfc.dbmodel.security.Operation readById(java.lang.Long id)
    {
        return getDao().load(id);
    }

    public java.util.List read(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.security.OperationImpl.class);

            if (name != null)
                criteria.add(Expression.ilike("name", name, MatchMode.START));
            if (description != null)
                criteria.add(Expression.ilike("description", description, MatchMode.START));
            if (url != null)
                criteria.add(Expression.ilike("url", url, MatchMode.START));
            if (parent != null)
            criteria.add(Expression.eq("parent", parent));
            if (ordre != null)
            criteria.add(Expression.eq("ordre", ordre));
            if (id != null)
            criteria.add(Expression.eq("id", id));
            if (roles != null && roles.length > 0) criteria.createCriteria("roles").add(Expression.in("id", roles));
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.List readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.security.OperationImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.Map readBackingLists()
    {
        final java.util.Map lists = new java.util.HashMap();
        final Session session = this.getSession();

        try
        {
            lists.put("roles", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.security.Role item order by item.id").list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    public edu.uoc.tfc.dbmodel.security.Operation update(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles)
    {
        final edu.uoc.tfc.dbmodel.security.Operation entity = this.getDao().load(id);

        entity.setName(name);
        entity.setDescription(description);
        entity.setUrl(url);
        entity.setParent(parent);
        entity.setOrdre(ordre);
        final java.util.Set rolesEntities = (roles != null && roles.length > 0)
            ? this.findRoleByIds(roles)
            : java.util.Collections.EMPTY_SET;

        entity.setRoles(rolesEntities);


        this.getDao().update(entity);
        return entity;
    }

    public void delete(java.lang.Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final org.hibernate.Query queryObject =
                session.createQuery("delete edu.uoc.tfc.dbmodel.security.OperationImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

}