// license-header java merge-point
package edu.uoc.tfc.dbmodel.security.crud;

public final class OperationManageableServiceBase
    implements OperationManageableService
{
    private edu.uoc.tfc.dbmodel.security.crud.OperationManageableDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.security.crud.OperationManageableDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.security.crud.OperationManageableDao getDao()
    {
        return this.dao;
    }

    public edu.uoc.tfc.dbmodel.security.crud.OperationValueObject create(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles)
        throws Exception
    {
        if (name == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.create(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'name' can not be null");
        }

        if (description == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.create(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'description' can not be null");
        }

        if (url == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.create(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'url' can not be null");
        }

        if (parent == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.create(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'parent' can not be null");
        }

        if (ordre == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.create(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'ordre' can not be null");
        }

        return toValueObject(dao.create(name, description, url, parent, ordre, id, roles));
    }

    public edu.uoc.tfc.dbmodel.security.crud.OperationValueObject readById(java.lang.Long id)
        throws Exception
    {
        return toValueObject(dao.readById(id));
    }

    public java.util.List read(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles)
        throws Exception
    {
        return toValueObjects(dao.read(name, description, url, parent, ordre, id, roles));
    }

    public java.util.List readAll()
        throws Exception
    {
        return toValueObjects(dao.readAll());
    }

    public java.util.Map readBackingLists()
        throws Exception
    {
        return getDao().readBackingLists();
    }

    public edu.uoc.tfc.dbmodel.security.crud.OperationValueObject update(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles)
        throws Exception
    {
        if (name == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.update(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'name' can not be null");
        }

        if (description == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.update(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'description' can not be null");
        }

        if (url == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.update(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'url' can not be null");
        }

        if (parent == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.update(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'parent' can not be null");
        }

        if (ordre == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.update(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'ordre' can not be null");
        }

        if (id == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.update(java.lang.String name, java.lang.String description, java.lang.String url, java.lang.Integer parent, java.lang.Integer ordre, java.lang.Long id, java.lang.Long[] roles) - 'id' can not be null");
        }

        return toValueObject(dao.update(name, description, url, parent, ordre, id, roles));
    }

    public void delete(java.lang.Long[] ids)
        throws Exception
    {
        if (ids == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.OperationManageableService.delete(java.lang.Long[] ids) - 'ids' can not be null");
        }

        dao.delete(ids);
    }


    private static java.util.List toValueObjects(java.util.Collection entities)
    {
        final java.util.List list = new java.util.ArrayList();

        for (java.util.Iterator iterator = entities.iterator(); iterator.hasNext();)
        {
            list.add(toValueObject((edu.uoc.tfc.dbmodel.security.Operation)iterator.next()));
        }

        return list;
    }

    private static edu.uoc.tfc.dbmodel.security.crud.OperationValueObject toValueObject(edu.uoc.tfc.dbmodel.security.Operation entity)
    {
        final edu.uoc.tfc.dbmodel.security.crud.OperationValueObject valueObject = new edu.uoc.tfc.dbmodel.security.crud.OperationValueObject();

        valueObject.setName(entity.getName());
        valueObject.setDescription(entity.getDescription());
        valueObject.setUrl(entity.getUrl());
        valueObject.setParent(entity.getParent());
        valueObject.setOrdre(entity.getOrdre());
        valueObject.setId(entity.getId());

        final java.util.Collection roles = entity.getRoles();
        if (roles == null || roles.isEmpty())
        {
            valueObject.setRoles(null);
        }
        else
        {
            final java.lang.Long[] values = new java.lang.Long[roles.size()];
            int counter = 0;
            for (final java.util.Iterator iterator = roles.iterator(); iterator.hasNext();counter++)
            {
                final edu.uoc.tfc.dbmodel.security.Role element = (edu.uoc.tfc.dbmodel.security.Role)iterator.next();
                values[counter] = element.getId();
            }
            valueObject.setRoles(values);
        }

        return valueObject;
    }
}
