// license-header java merge-point
package edu.uoc.tfc.dbmodel.security.crud;

import org.hibernate.Session;
import org.hibernate.Criteria;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Expression;

public final class RoleManageableDaoBase
    extends org.springframework.orm.hibernate3.support.HibernateDaoSupport
    implements RoleManageableDao
{
    private edu.uoc.tfc.dbmodel.security.RoleDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.security.RoleDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.security.RoleDao getDao()
    {
        return this.dao;
    }

    private edu.uoc.tfc.dbmodel.security.UserDao usersDao = null;

    public void setUsersDao(edu.uoc.tfc.dbmodel.security.UserDao usersDao)
    {
        this.usersDao = usersDao;
    }

    protected edu.uoc.tfc.dbmodel.security.UserDao getUsersDao()
    {
        return this.usersDao;
    }

    private edu.uoc.tfc.dbmodel.security.OperationDao operationsDao = null;

    public void setOperationsDao(edu.uoc.tfc.dbmodel.security.OperationDao operationsDao)
    {
        this.operationsDao = operationsDao;
    }

    protected edu.uoc.tfc.dbmodel.security.OperationDao getOperationsDao()
    {
        return this.operationsDao;
    }

    private java.util.Set findUserByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.security.UserImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    private java.util.Set findOperationByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.security.OperationImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public edu.uoc.tfc.dbmodel.security.Role create(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations)
    {
        final edu.uoc.tfc.dbmodel.security.Role entity = new edu.uoc.tfc.dbmodel.security.RoleImpl();
        entity.setRoleId(roleId);
        entity.setDescription(description);
        entity.setId(id);
        final java.util.Set usersEntities = (users != null && users.length > 0)
            ? this.findUserByIds(users)
            : java.util.Collections.EMPTY_SET;

        entity.setUsers(usersEntities);

        final java.util.Set operationsEntities = (operations != null && operations.length > 0)
            ? this.findOperationByIds(operations)
            : java.util.Collections.EMPTY_SET;

        entity.setOperations(operationsEntities);


        return (edu.uoc.tfc.dbmodel.security.Role)this.getDao().create(entity);
    }

    public edu.uoc.tfc.dbmodel.security.Role readById(java.lang.Long id)
    {
        return getDao().load(id);
    }

    public java.util.List read(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.security.RoleImpl.class);

            if (roleId != null)
                criteria.add(Expression.ilike("roleId", roleId, MatchMode.START));
            if (description != null)
                criteria.add(Expression.ilike("description", description, MatchMode.START));
            if (id != null)
            criteria.add(Expression.eq("id", id));
            if (users != null && users.length > 0) criteria.createCriteria("users").add(Expression.in("id", users));
            if (operations != null && operations.length > 0) criteria.createCriteria("operations").add(Expression.in("id", operations));
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.List readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.security.RoleImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.Map readBackingLists()
    {
        final java.util.Map lists = new java.util.HashMap();
        final Session session = this.getSession();

        try
        {
            lists.put("users", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.security.User item order by item.id").list());
            lists.put("operations", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.security.Operation item order by item.id").list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    public edu.uoc.tfc.dbmodel.security.Role update(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations)
    {
        final edu.uoc.tfc.dbmodel.security.Role entity = this.getDao().load(id);

        entity.setRoleId(roleId);
        entity.setDescription(description);
        final java.util.Set usersEntities = (users != null && users.length > 0)
            ? this.findUserByIds(users)
            : java.util.Collections.EMPTY_SET;

        entity.setUsers(usersEntities);

        final java.util.Set operationsEntities = (operations != null && operations.length > 0)
            ? this.findOperationByIds(operations)
            : java.util.Collections.EMPTY_SET;

        entity.setOperations(operationsEntities);


        this.getDao().update(entity);
        return entity;
    }

    public void delete(java.lang.Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final org.hibernate.Query queryObject =
                session.createQuery("delete edu.uoc.tfc.dbmodel.security.RoleImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

}