// license-header java merge-point
package edu.uoc.tfc.dbmodel.security.crud;

public final class RoleManageableServiceBase
    implements RoleManageableService
{
    private edu.uoc.tfc.dbmodel.security.crud.RoleManageableDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.security.crud.RoleManageableDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.security.crud.RoleManageableDao getDao()
    {
        return this.dao;
    }

    public edu.uoc.tfc.dbmodel.security.crud.RoleValueObject create(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations)
        throws Exception
    {
        if (roleId == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.RoleManageableService.create(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations) - 'roleId' can not be null");
        }

        if (description == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.RoleManageableService.create(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations) - 'description' can not be null");
        }

        return toValueObject(dao.create(roleId, description, id, users, operations));
    }

    public edu.uoc.tfc.dbmodel.security.crud.RoleValueObject readById(java.lang.Long id)
        throws Exception
    {
        return toValueObject(dao.readById(id));
    }

    public java.util.List read(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations)
        throws Exception
    {
        return toValueObjects(dao.read(roleId, description, id, users, operations));
    }

    public java.util.List readAll()
        throws Exception
    {
        return toValueObjects(dao.readAll());
    }

    public java.util.Map readBackingLists()
        throws Exception
    {
        return getDao().readBackingLists();
    }

    public edu.uoc.tfc.dbmodel.security.crud.RoleValueObject update(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations)
        throws Exception
    {
        if (roleId == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.RoleManageableService.update(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations) - 'roleId' can not be null");
        }

        if (description == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.RoleManageableService.update(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations) - 'description' can not be null");
        }

        if (id == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.RoleManageableService.update(java.lang.String roleId, java.lang.String description, java.lang.Long id, java.lang.Long[] users, java.lang.Long[] operations) - 'id' can not be null");
        }

        return toValueObject(dao.update(roleId, description, id, users, operations));
    }

    public void delete(java.lang.Long[] ids)
        throws Exception
    {
        if (ids == null)
        {
            throw new IllegalArgumentException(
                "edu.uoc.tfc.dbmodel.security.crud.RoleManageableService.delete(java.lang.Long[] ids) - 'ids' can not be null");
        }

        dao.delete(ids);
    }


    private static java.util.List toValueObjects(java.util.Collection entities)
    {
        final java.util.List list = new java.util.ArrayList();

        for (java.util.Iterator iterator = entities.iterator(); iterator.hasNext();)
        {
            list.add(toValueObject((edu.uoc.tfc.dbmodel.security.Role)iterator.next()));
        }

        return list;
    }

    private static edu.uoc.tfc.dbmodel.security.crud.RoleValueObject toValueObject(edu.uoc.tfc.dbmodel.security.Role entity)
    {
        final edu.uoc.tfc.dbmodel.security.crud.RoleValueObject valueObject = new edu.uoc.tfc.dbmodel.security.crud.RoleValueObject();

        valueObject.setRoleId(entity.getRoleId());
        valueObject.setDescription(entity.getDescription());
        valueObject.setId(entity.getId());

        final java.util.Collection users = entity.getUsers();
        if (users == null || users.isEmpty())
        {
            valueObject.setUsers(null);
        }
        else
        {
            final java.lang.Long[] values = new java.lang.Long[users.size()];
            int counter = 0;
            for (final java.util.Iterator iterator = users.iterator(); iterator.hasNext();counter++)
            {
                final edu.uoc.tfc.dbmodel.security.User element = (edu.uoc.tfc.dbmodel.security.User)iterator.next();
                values[counter] = element.getId();
            }
            valueObject.setUsers(values);
        }

        final java.util.Collection operations = entity.getOperations();
        if (operations == null || operations.isEmpty())
        {
            valueObject.setOperations(null);
        }
        else
        {
            final java.lang.Long[] values = new java.lang.Long[operations.size()];
            int counter = 0;
            for (final java.util.Iterator iterator = operations.iterator(); iterator.hasNext();counter++)
            {
                final edu.uoc.tfc.dbmodel.security.Operation element = (edu.uoc.tfc.dbmodel.security.Operation)iterator.next();
                values[counter] = element.getId();
            }
            valueObject.setOperations(values);
        }

        return valueObject;
    }
}
