// license-header java merge-point
package edu.uoc.tfc.dbmodel.security.crud;

import org.hibernate.Session;
import org.hibernate.Criteria;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Expression;

public final class UserManageableDaoBase
    extends org.springframework.orm.hibernate3.support.HibernateDaoSupport
    implements UserManageableDao
{
    private edu.uoc.tfc.dbmodel.security.UserDao dao;

    public void setDao(edu.uoc.tfc.dbmodel.security.UserDao dao)
    {
        this.dao = dao;
    }

    protected edu.uoc.tfc.dbmodel.security.UserDao getDao()
    {
        return this.dao;
    }

    private edu.uoc.tfc.dbmodel.security.RoleDao rolDao = null;

    public void setRolDao(edu.uoc.tfc.dbmodel.security.RoleDao rolDao)
    {
        this.rolDao = rolDao;
    }

    protected edu.uoc.tfc.dbmodel.security.RoleDao getRolDao()
    {
        return this.rolDao;
    }

    private java.util.Set findRoleByIds(java.lang.Long[] ids)
    {
        final Session session = this.getSession(false);
        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.security.RoleImpl.class);
            criteria.add(Expression.in("id", ids));
            return new java.util.HashSet(criteria.list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public edu.uoc.tfc.dbmodel.security.User create(java.lang.String userId, java.lang.String password, java.lang.String adress, java.lang.Boolean active, java.lang.String nom, java.lang.String primerCognom, java.lang.String segonCognom, java.lang.Long id, java.lang.Long rol)
    {
        final edu.uoc.tfc.dbmodel.security.User entity = new edu.uoc.tfc.dbmodel.security.UserImpl();
        entity.setUserId(userId);
        entity.setPassword(password);
        entity.setAdress(adress);
        entity.setActive(active);
        entity.setNom(nom);
        entity.setPrimerCognom(primerCognom);
        entity.setSegonCognom(segonCognom);
        entity.setId(id);
        edu.uoc.tfc.dbmodel.security.Role rolEntity = null;
        if (rol != null)
        {
            rolEntity = (edu.uoc.tfc.dbmodel.security.Role)getRolDao().load(rol);
        }

        entity.setRol(rolEntity);


        return (edu.uoc.tfc.dbmodel.security.User)this.getDao().create(entity);
    }

    public edu.uoc.tfc.dbmodel.security.User readById(java.lang.Long id)
    {
        return getDao().load(id);
    }

    public java.util.List read(java.lang.String userId, java.lang.String password, java.lang.String adress, java.lang.Boolean active, java.lang.String nom, java.lang.String primerCognom, java.lang.String segonCognom, java.lang.Long id, java.lang.Long rol)
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.security.UserImpl.class);

            if (userId != null)
                criteria.add(Expression.ilike("userId", userId, MatchMode.START));
            if (password != null)
                criteria.add(Expression.ilike("password", password, MatchMode.START));
            if (adress != null)
                criteria.add(Expression.ilike("adress", adress, MatchMode.START));
            if (active != null)
            if (active.booleanValue()) criteria.add(Expression.eq("active", java.lang.Boolean.TRUE));
            if (nom != null)
                criteria.add(Expression.ilike("nom", nom, MatchMode.START));
            if (primerCognom != null)
                criteria.add(Expression.ilike("primerCognom", primerCognom, MatchMode.START));
            if (segonCognom != null)
                criteria.add(Expression.ilike("segonCognom", segonCognom, MatchMode.START));
            if (id != null)
            criteria.add(Expression.eq("id", id));
            if (rol != null) criteria.createCriteria("rol").add(Expression.eq("id", rol));
            criteria.setMaxResults(250);

            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.List readAll()
    {
        final Session session = getSession(false);

        try
        {
            final Criteria criteria = session.createCriteria(edu.uoc.tfc.dbmodel.security.UserImpl.class);
            criteria.setMaxResults(250);
            return criteria.list();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

    public java.util.Map readBackingLists()
    {
        final java.util.Map lists = new java.util.HashMap();
        final Session session = this.getSession();

        try
        {
            lists.put("rol", session.createQuery("select item.id, item.id from edu.uoc.tfc.dbmodel.security.Role item order by item.id").list());
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
        return lists;
    }

    public edu.uoc.tfc.dbmodel.security.User update(java.lang.String userId, java.lang.String password, java.lang.String adress, java.lang.Boolean active, java.lang.String nom, java.lang.String primerCognom, java.lang.String segonCognom, java.lang.Long id, java.lang.Long rol)
    {
        final edu.uoc.tfc.dbmodel.security.User entity = this.getDao().load(id);

        entity.setUserId(userId);
        entity.setPassword(password);
        entity.setAdress(adress);
        entity.setActive(active);
        entity.setNom(nom);
        entity.setPrimerCognom(primerCognom);
        entity.setSegonCognom(segonCognom);
        edu.uoc.tfc.dbmodel.security.Role rolEntity = null;
        if (rol != null)
        {
            rolEntity = getRolDao().load(rol);
        }

        entity.setRol(rolEntity);


        this.getDao().update(entity);
        return entity;
    }

    public void delete(java.lang.Long[] ids)
    {
        final Session session = getSession(false);
        try
        {
            final org.hibernate.Query queryObject =
                session.createQuery("delete edu.uoc.tfc.dbmodel.security.UserImpl where id in (:ids)");
            queryObject.setParameterList("ids", ids);
            queryObject.executeUpdate();
        }
        catch (org.hibernate.HibernateException ex)
        {
            throw super.convertHibernateAccessException(ex);
        }
    }

}