// license-header java merge-point
package edu.uoc.tfc.gui.security.gestioUsuaris.modificaUsuari;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionMapping;

import edu.uoc.tfc.dto.security.RoleVO;
import edu.uoc.tfc.gui.common.Level;
import edu.uoc.tfc.gui.common.MissatgeAjax;
import edu.uoc.tfc.gui.common.Option;
import edu.uoc.tfc.gui.common.ResultatAccioAjaxVO;
import edu.uoc.tfc.gui.common.SelectBox;

/**
 * @see edu.uoc.tfc.gui.security.gestioUsuaris.modificaUsuari.ModificaUsuariController
 */
public class ModificaUsuariControllerImpl extends ModificaUsuariController
{
    /**
     * @see edu.uoc.tfc.gui.security.gestioUsuaris.modificaUsuari.ModificaUsuariController#modificaUsuari(org.apache.struts.action.ActionMapping, edu.uoc.tfc.gui.security.gestioUsuaris.modificaUsuari.ModificaUsuariForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    public final void modificaUsuari(ActionMapping mapping, edu.uoc.tfc.gui.security.gestioUsuaris.modificaUsuari.ModificaUsuariForm form, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
    	getSecurityService().
    		modificaUsuari(form.getUsuari(),form.getRoleId());
    	
    	MissatgeAjax missatge = new MissatgeAjax("cu.modificacio.success", null, Level.Success);
    	ResultatAccioAjaxVO resultat = new ResultatAccioAjaxVO();
    	resultat.addMessage(missatge);
    	form.setResultat(resultat);
    }

    /**
     * @see edu.uoc.tfc.gui.security.gestioUsuaris.modificaUsuari.ModificaUsuariController#obtenirUsuari(org.apache.struts.action.ActionMapping, edu.uoc.tfc.gui.security.gestioUsuaris.modificaUsuari.ObtenirUsuariForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    public final void obtenirUsuari(ActionMapping mapping, edu.uoc.tfc.gui.security.gestioUsuaris.modificaUsuari.ObtenirUsuariForm form, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        form.setUsuari(
        	getSecurityService().
        		getUsuariDetall(form.getUserId()));
    }

	@Override
	public void carregaRols(ActionMapping mapping, CarregaRolsForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
    	SelectBox selectResultado = new SelectBox();

    	RoleVO[] roles = this.getSecurityService()
    			.carregaRols();

    	Option[] options = new Option[roles.length];
    	for (int i=0; i<roles.length; i++){
    		Option o = new Option();
    		RoleVO r = roles[i];
    		
    		o.setOptionDisplay(r.getRoleId());
    		o.setOptionValue(r.getId().toString());
    		options[i]=o;
    	}
    	
    	selectResultado.setOptions(options);
    	form.setSelectResultat(selectResultado);		
		
	}

}