
var oTable;
var oTableModal;



function getTable() {
	if (modal.isOpen){
		return oTableModal;
	}else{
		return oTable;
	}
}



function setTable(newTable) {
	if (modal.isOpen){
		oTableModal = newTable;
	}else{
		oTable = newTable;
	}
}



/* Default class modification */
$.extend($.fn.dataTableExt.oStdClasses, {
	'sSortAsc': 'header headerSortDown',
	'sSortDesc': 'header headerSortUp',
	'sSortable': 'header'
});



/* API method to get paging information */
$.fn.dataTableExt.oApi.fnPagingInfo = function (oSettings) {
	return {
		'iStart':oSettings._iDisplayStart,
		'iEnd':oSettings.fnDisplayEnd(),
		'iLength':oSettings._iDisplayLength,
		'iTotal':oSettings.fnRecordsTotal(),
		'iFilteredTotal':oSettings.fnRecordsDisplay(),
		'iPage':Math.ceil( oSettings._iDisplayStart / oSettings._iDisplayLength ),
		'iTotalPages':Math.ceil( oSettings.fnRecordsDisplay() / oSettings._iDisplayLength )
	};
}



///* Bootstrap style pagination control */
$.extend( $.fn.dataTableExt.oPagination, {
	'bootstrap': {
		'fnInit': function(oSettings, nPaging, fnCallbackDraw) {
			var oLang = oSettings.oLanguage.oPaginate;
			var fnClickHandler = function (e) {
				if (oSettings.oApi._fnPageChange(oSettings, e.data.action)) {
					fnCallbackDraw(oSettings);
				}
			};
			$(nPaging).addClass('pagination').append(
				'<ul>'+
				'<li class="first disabled"><a href="#">'+oLang.sFirst+'</a></li>'+
				'<li class="prev disabled"><a href="#">'+oLang.sPrevious+'</a></li>'+
				'<li class="next disabled"><a href="#">'+oLang.sNext+'</a></li>'+
				'<li class="last disabled"><a href="#">'+oLang.sLast+'</a></li>'+
				'</ul>'
			);
			var els = $('a', nPaging);
			$(els[0]).bind('click.DT', {action: 'first'}, fnClickHandler);
			$(els[1]).bind('click.DT', {action: 'previous'}, fnClickHandler);
			$(els[2]).bind('click.DT', {action: 'next'}, fnClickHandler);
			$(els[3]).bind('click.DT', {action: 'last'}, fnClickHandler);
		},
		'fnUpdate': function (oSettings, fnCallbackDraw) {
			if (!oSettings.aanFeatures.p) {
				return;
			}
			var iPageCount = $.fn.DataTable.ext.oPagination.iFullNumbersShowPages;
			var iPageCountHalf = Math.floor(iPageCount / 2);
			var iPages = Math.ceil((oSettings.fnRecordsDisplay()) / oSettings._iDisplayLength);
			var iCurrentPage = Math.ceil(oSettings._iDisplayStart / oSettings._iDisplayLength) + 1;
			var iStartButton, iEndButton, i;
			var oPaging = oSettings.oInstance.fnPagingInfo();
			var an = oSettings.aanFeatures.p;
			/* Pages calculation */
			if (iPages < iPageCount){
				iStartButton = 1;
				iEndButton = iPages;
			}else if (iCurrentPage <= iPageCountHalf){
				iStartButton = 1;
				iEndButton = iPageCount;
			}else if (iCurrentPage >= (iPages - iPageCountHalf)){
				iStartButton = iPages - iPageCount + 1;
				iEndButton = iPages;
			}else{
				iStartButton = iCurrentPage - Math.ceil(iPageCount / 2) + 1;
				iEndButton = iStartButton + iPageCount - 1;
			}
			// Remove the middle elements
			if (getTable()){
				var tableName = getTable().attr('id');
				$('#' + tableName + '_wrapper li').slice(2,$('#' + tableName + '_wrapper li').length-2).remove();
				// Add the new list items and their event handlers
				for (i = iStartButton ; i <= iEndButton ; i++) {
					sClass = (i==oPaging.iPage+1) ? 'class="active"' : '';
					$('<li '+sClass+'><a href="#">'+i+'</a></li>')
						.insertBefore('#' + tableName + '_wrapper li.next', an[i])
						.bind('click', function () {
							oSettings._iDisplayStart = (parseInt($('a', this).text(),10)-1) * oPaging.iLength;
							fnCallbackDraw( oSettings );
						});
				}
				// Add / remove disabled classes from the static elements
				if (oPaging.iPage === 0) {
					$('#' + tableName + '_wrapper li.first', an[i]).addClass('disabled');
					$('#' + tableName + '_wrapper li.prev', an[i]).addClass('disabled');
				} else {
					$('#' + tableName + '_wrapper li.first', an[i]).removeClass('disabled');
					$('#' + tableName + '_wrapper li.prev', an[i]).removeClass('disabled');
				}
				if (oPaging.iPage === oPaging.iTotalPages-1) {
					$('#' + tableName + '_wrapper li.last', an[i]).addClass('disabled');
					$('#' + tableName + '_wrapper li.next', an[i]).addClass('disabled');
				} else {
					$('#' + tableName + '_wrapper li.last', an[i]).removeClass('disabled');
					$('#' + tableName + '_wrapper li.next', an[i]).removeClass('disabled');
				}
				/* defino un ancla para que al pulsar en la paginacion el foco de la pagina no se vaya al top */
				$('.pagination li a').attr('href', '#ancla');
				$('.pagination a').attr('href', '#ancla');
			}
		}
	}
});



function fnGetSelected(oTableLocal) {
  return oTableLocal.$('tr.row_selected');
}



function getSelectedId(oTableLocal) {
  return fnGetSelected(oTableLocal).attr('id');
}



function buscarDelegate(oTableLocal, tableName, urlAction, columns, columnDefs, bytoken) {
	oCache = {
		iCacheLower: -1
	};
	var DISPLAY_LENGTH = 10;
	var oLanguage = {
		'oPaginate': {
			'sFirst': LOCALE.DATATABLES.FIRST,
			'sPrevious': LOCALE.DATATABLES.PREVIOUS,
			'sNext': LOCALE.DATATABLES.NEXT,
			'sLast': LOCALE.DATATABLES.LAST,
			'sLengthMenu': LOCALE.DATATABLES.SHOWING + ' _MENU_ ' + LOCALE.DATATABLES.TOTAL
		},
		'sEmptyTable': LOCALE.DATATABLES.EMPTY_TABLE,
		'sInfo': LOCALE.DATATABLES.INFO,
		'sInfoEmpty': LOCALE.DATATABLES.INFO_EMPTY,
		'sInfoFiltered': LOCALE.DATATABLES.INFO_FILTERED,
		'sLoadingRecords': LOCALE.DATATABLES.LOADING,
		'sProcessing': LOCALE.DATATABLES.PROCESSING,
		'sSearch': LOCALE.DATATABLES.SEARCH,
		'sZeroRecords': LOCALE.DATATABLES.ZERO_RECORDS
	};
	if (urlAction) {
		if ($('#' + tableName + 'Form').length == 0) {
			messages.error(LOCALE.DATATABLES.FORM_ERROR);
			return false;
		}
		var values = $('#' + tableName + 'Form').serializeObject();
		if (bytoken){
			values['token'] = generateToken();  
		}

		/* Init the table */
		oTableLocal = $('#' + tableName + '').dataTable({
			'sDom': "<'row'<'span3'l><'span8'f>r>t<'row'<'span4'i><p>>",
//			'sDom': "<'row'<'span3'l><'span6'T>r>t<'row'<'span4'i><p>>",
//			'oTableTools': {
//				'sSwfPath': '../layout/swf/copy_csv_xls_pdf.swf',
//				'aButtons': [
//					{
//						'sExtends': 'copy',
//						'sButtonText': LOCALE.TABLETOOLS.COPY
//					},{
//						'sExtends': 'csv',
//						'sButtonText': LOCALE.TABLETOOLS.CSV,
//						sTitle: breadcrumbs.print()
//					},{
//						'sExtends': 'xls',
//						'sButtonText': LOCALE.TABLETOOLS.EXCEL,
//						'sTitle': breadcrumbs.print()
//					},{
//						'sExtends': 'pdf',
//						'sButtonText': LOCALE.TABLETOOLS.PDF,
//						'sPdfMessage': document.title, 
//						'sTitle': breadcrumbs.print(),
//						'bShowAll': true
//					},{
//						'sExtends': 'print',
//						'sButtonText': LOCALE.TABLETOOLS.PRINT
//					}
//				]
//			},
			'sPaginationType': 'bootstrap',
			'oLanguage': oLanguage,
			'bFilter': false,
			'bLengthChange': false, // activa o desactiva el selector de nmero de items mostrados por pgina
			'bProcessing': true,
			'bServerSide': true,
			'bPaginate': true,
			'iDisplayLength' : DISPLAY_LENGTH,
			//'iDeferLoading' : null,
			'bSort': false,
			'sAjaxSource': urlAction,
			// Sobreescribimos la llamada AJAX para tener control sobre el callback en caso de error
			'fnServerData': fnDataTablesPipeline,
			// Sobreescribimos el paso de parametros para adjuntarle los campos del formulario del filtro
			'fnServerParams': function (aoData) {
				jQuery.each(values, function(key, value) {
					aoData.push({ 'name': key, 'value': value });
				});
			},
			'aoColumns': columns,
			'aoColumnDefs': columnDefs,
			'bDestroy': true
		});
	} else {
		oTableLocal = $('#' + tableName + '').dataTable({
			'sDom': "<'row'<'span3'l><'span8'f>r>t<'row'<'span4'i><'span5'p>>",
			'sPaginationType': 'bootstrap',
			'oLanguage': oLanguage,
			'bFilter': false,
			'bLengthChange': false,
			'bProcessing': true,
			'bSort': false,
			'bPaginate': true,
			'iDisplayLength' : DISPLAY_LENGTH,
			'aoColumns': columns,
			'aoColumnDefs': columnDefs,
			'bDestroy': true
		});
	}
	oTableLocal.width('100%');
	setTable(oTableLocal);
}



$(document).on('click', '.single tbody tr', function (e) {
	var selectedTr = $(this);
	selectedTr
		.closest('table')
	  	.find('tr')
	  	.not(selectedTr)
	  	.removeClass('row_selected');
	selectedTr
	  	.toggleClass('row_selected');
});



$(document).on('click', '.multiple tbody tr', function (e) {
	$(this).toggleClass('row_selected');
});



var oCache = {
	iCacheLower: -1
};



function fnSetKey(aoData, sKey, mValue) {
	for (var i = 0, iLen = aoData.length ; i < iLen ; i++) {
        if (aoData[i].name == sKey) {
            aoData[i].value = mValue;
        }
    }
}



function fnGetKey(aoData, sKey) {
    for (var i = 0, iLen = aoData.length ; i < iLen ; i++) {
        if (aoData[i].name == sKey) {
            return aoData[i].value;
        }
    }
    return null;
}



function fnDataTablesPipeline (sSource, aoData, fnCallback) {
	var iPipe = 5; /* Ajust the pipe size */

	var bNeedServer = false;
	var sEcho = fnGetKey(aoData, 'sEcho');
	var iRequestStart = fnGetKey(aoData, 'iDisplayStart');
	var iRequestLength = fnGetKey(aoData, 'iDisplayLength');
	var iRequestEnd = iRequestStart + iRequestLength;
	oCache.iDisplayStart = iRequestStart;

	/* outside pipeline? */
	if (oCache.iCacheLower < 0 || iRequestStart < oCache.iCacheLower || iRequestEnd > oCache.iCacheUpper) {
		bNeedServer = true;
	}

	/* sorting etc changed? */
	if (oCache.lastRequest && !bNeedServer) {
		for (var i = 0, iLen = aoData.length ; i < iLen ; i++ ) {
			if ( aoData[i].name != 'iDisplayStart' && aoData[i].name != 'iDisplayLength' && aoData[i].name != 'sEcho' && aoData[i].name != 'token' ) {
				if (aoData[i].value != oCache.lastRequest[i].value) {
					bNeedServer = true;
					break;
				}
			}
		}
	}

	/* Store the request for checking next time around */
	oCache.lastRequest = aoData.slice();

	if (bNeedServer) {
		if (iRequestStart < oCache.iCacheLower) {
			iRequestStart = iRequestStart - (iRequestLength*(iPipe-1));
			if (iRequestStart < 0) {
				iRequestStart = 0;
			}
		}

		oCache.iCacheLower = iRequestStart;
		oCache.iCacheUpper = iRequestStart + (iRequestLength * iPipe);
		oCache.iDisplayLength = fnGetKey(aoData, 'iDisplayLength');
		fnSetKey(aoData, 'iDisplayStart', iRequestStart);
		fnSetKey(aoData, 'iDisplayLength', iRequestLength*iPipe);

//        var tokenTemp = generateToken();
        jQuery.each(aoData, function(key, value) {
//        	if (value.name === 'token') {
//        		value.value = tokenTemp;
//        	}
        });

		$.ajax({
			url: sSource,
			dataType: 'json',
			data: aoData,
			cache: false,
			success: function (json) {
				oCache.lastJson = jQuery.extend(true, {}, json);
				if (oCache.iCacheLower != oCache.iDisplayStart) {
					json.aaData.splice( 0, oCache.iDisplayStart-oCache.iCacheLower );
				}
	            if ( oCache.iDisplayLength >= 0 ){
	                json.aaData.splice( oCache.iDisplayLength, json.aaData.length );
	            }
				fnCallback(json);
			},
			error: errorDefault
		});
	} else {
		json = jQuery.extend(true, {}, oCache.lastJson);
		if (json.aaData){
			json.sEcho = sEcho; /* Update the echo for each response */
			json.aaData.splice( 0, iRequestStart-oCache.iCacheLower );
	        if (iRequestLength >= 0){
	            json.aaData.splice( iRequestLength, json.aaData.length );
	        }
	        fnCallback(json);
		}else{
			getTable()._fnProcessingDisplay(false);
		}
		return;
	}
}



function getColumnData(selectedRow, index) {
	var cells = $(selectedRow).find('td');
	return cells.eq(index).html();
}



function fnDeleteSelectedRows() {
	var oTableLocal = getTable();
	var anSelected = fnGetSelected(oTableLocal);
	$(anSelected).each(function(index) {
		oTableLocal.fnDeleteRow(anSelected[index]);
	});
}



function renderString(obj, val){
	return val;
}

function fnGetPositionById(data, id){
	var indexResult;
	$(data).each(function(index){
		if (id==data[index].literal){
			indexResult = index;
			return;
		}
	});
	return indexResult;
}

	/**
	 * Objeto que almacena los datos editados en un Datatable cuando ponemos Inputs, 
	 * por ejemplo en el Alta de Consumidor de Registro (y en el Wizard que lo incluye).
	 */
	var tableValues = {
		hashMap: undefined,
		init: function() {
			this.hashMap = {};
		},
		setValue: function(key, value) {
			this.hashMap[key] = value;
		},
		getValue: function(key) {
			var returnValue = this.hashMap[key];
			
			if (!returnValue) {
				return '';	
			}
			
			return returnValue;
		},
		serialize: function() {
			$.each(this.hashMap, function (key, value) {
				tableValues.serializeItem(key, value);
			});
		},
		serializeItem : function(key, value) {
			// Implement
		}
	};

	$(document).on('change', '.emkt-datatable-input', function(e){
		var theAnchor = $(this);
		tableValues.setValue(theAnchor.attr('id'), theAnchor.val());
	});
