
var messages = {
	ALERT: '#emkt-alert',
	ALERT_MODAL: '#modal-alert',
    init: function() {
    	$(document).on('click', '#emkt-alert a', function(e) {
    		messages.hide(messages.ALERT);
    	});
    	$(document).on('click', '#modal-alert a', function(e) {
    		messages.hide(messages.ALERT_MODAL);
    	});
    },
	error: function(message) {
		if (!message || message == ''){
			message = LOCALE.ERROR;
		}
		this.show('alert-error', message);
		loading.forceHide();
	},
	warn: function(message) {
		this.show('alert-block', message);
	},
	info: function(message) {
		this.show('alert-info', message);
	},
	success: function(message) {
		this.show('alert-success', message);
	},
	show: function(className, message) {
		var m;
		var modalOpen = modal.isOpen;
		if (modalOpen){
			m = $(this.ALERT_MODAL);
		}else{
			m = $(this.ALERT);
		}
		m.find('div').html(message);
		m.removeClass().addClass('alert fade in ' + className).show();
		if (modalOpen){
			modal.resize();
		}
		document.location.href= '#';
	},
	hide: function(id) {
		if (id){
			var m = $(id);
			m.hide();
			if (modal.isOpen){
				modal.resize();
			}
		}else{
			this.hide(this.ALERT);
			this.hide(this.ALERT_MODAL);
		}
	},
	isModalAlertShown: function() {
		return $(messages.ALERT_MODAL).css('display') != 'none';
	},
	moveMessage: function() {
		var ma = $(messages.ALERT_MODAL);
		var m = $(messages.ALERT);
		m.html(ma.html());
		m.attr('class', ma.attr('class'));
		m.show();
	}
};
messages.init();
