// license-header java merge-point
package edu.uoc.tfc.dbmodel.crud;

import org.apache.struts.actions.DispatchAction;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;

public final class ManageClient extends DispatchAction
{
    public ActionForward execute(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        request.getSession().setAttribute("manageableForm", actionForm);
        return super.execute(mapping, actionForm, request, response);
    }

    public ActionForward create(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.ClientForm form = (edu.uoc.tfc.dbmodel.crud.ClientForm)actionForm;

        edu.uoc.tfc.ManageableServiceLocator.instance().getClientManageableService().create(
            (StringUtils.isBlank(request.getParameter("dni"))) ? null : form.getDni()
            , (StringUtils.isBlank(request.getParameter("nom"))) ? null : form.getNom()
            , (StringUtils.isBlank(request.getParameter("primerCognom"))) ? null : form.getPrimerCognom()
            , (StringUtils.isBlank(request.getParameter("segonCognom"))) ? null : form.getSegonCognom()
            , (StringUtils.isBlank(request.getParameter("telefon"))) ? null : form.getTelefon()
            , (StringUtils.isBlank(request.getParameter("mail"))) ? null : form.getMail()
            , (StringUtils.isBlank(request.getParameter("dataNaixement"))) ? null : form.getDataNaixement()
            , (StringUtils.isBlank(request.getParameter("actiu"))) ? null : form.getActiu()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("partsDelClient"))) ? null : form.getPartsDelClient()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward read(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.ClientForm form = (edu.uoc.tfc.dbmodel.crud.ClientForm)actionForm;

        final java.util.List list = edu.uoc.tfc.ManageableServiceLocator.instance().getClientManageableService().read(
            (StringUtils.isBlank(request.getParameter("dni"))) ? null : form.getDni()
            , (StringUtils.isBlank(request.getParameter("nom"))) ? null : form.getNom()
            , (StringUtils.isBlank(request.getParameter("primerCognom"))) ? null : form.getPrimerCognom()
            , (StringUtils.isBlank(request.getParameter("segonCognom"))) ? null : form.getSegonCognom()
            , (StringUtils.isBlank(request.getParameter("telefon"))) ? null : form.getTelefon()
            , (StringUtils.isBlank(request.getParameter("mail"))) ? null : form.getMail()
            , (StringUtils.isBlank(request.getParameter("dataNaixement"))) ? null : form.getDataNaixement()
            , (StringUtils.isBlank(request.getParameter("actiu"))) ? null : form.getActiu()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("partsDelClient"))) ? null : form.getPartsDelClient()
        );
        form.setManageableList(list);

        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final java.util.Map backingLists = edu.uoc.tfc.ManageableServiceLocator.instance().getClientManageableService().readBackingLists();
        form.setPartsDelClientBackingList((java.util.List)backingLists.get("partsDelClient"));

        return mapping.getInputForward();
    }

    public ActionForward preload(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.ClientForm form = (edu.uoc.tfc.dbmodel.crud.ClientForm)actionForm;

        final java.util.List list = edu.uoc.tfc.ManageableServiceLocator.instance().getClientManageableService().readAll();
        form.setManageableList(list);


        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final java.util.Map backingLists = edu.uoc.tfc.ManageableServiceLocator.instance().getClientManageableService().readBackingLists();
        if (StringUtils.isNotBlank(request.getParameter("ref_Part")))
        {
            final java.lang.Long[] array = new java.lang.Long[1];
            array[0] = new java.lang.Long(request.getParameter("ref_Part"));
            form.setPartsDelClient(array);
        }
        form.setPartsDelClientBackingList((java.util.List)backingLists.get("partsDelClient"));

        return mapping.getInputForward();
    }

    protected ActionForward unspecified(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        return preload(mapping, actionForm, request, response);
    }

    public ActionForward update(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.ClientForm form = (edu.uoc.tfc.dbmodel.crud.ClientForm) actionForm;

        edu.uoc.tfc.ManageableServiceLocator.instance().getClientManageableService().update(
            (StringUtils.isBlank(request.getParameter("dni"))) ? null : form.getDni()
            , (StringUtils.isBlank(request.getParameter("nom"))) ? null : form.getNom()
            , (StringUtils.isBlank(request.getParameter("primerCognom"))) ? null : form.getPrimerCognom()
            , (StringUtils.isBlank(request.getParameter("segonCognom"))) ? null : form.getSegonCognom()
            , (StringUtils.isBlank(request.getParameter("telefon"))) ? null : form.getTelefon()
            , (StringUtils.isBlank(request.getParameter("mail"))) ? null : form.getMail()
            , (StringUtils.isBlank(request.getParameter("dataNaixement"))) ? null : form.getDataNaixement()
            , (StringUtils.isBlank(request.getParameter("actiu"))) ? null : form.getActiu()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("partsDelClient"))) ? null : form.getPartsDelClient()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward delete(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.ClientForm form = (edu.uoc.tfc.dbmodel.crud.ClientForm) actionForm;

        final java.lang.Long[] selectedRows = form.getSelectedRows();
        if (selectedRows != null && selectedRows.length > 0)
        {
            edu.uoc.tfc.ManageableServiceLocator.instance().getClientManageableService().delete(selectedRows);
        }

        return preload(mapping, actionForm, request, response);
    }

    private void saveMaxResultsWarning(HttpServletRequest request)
    {
        final HttpSession session = request.getSession();

        ActionMessages messages = (ActionMessages)session.getAttribute(org.apache.struts.Globals.MESSAGE_KEY);
        if (messages == null)
        {
            messages = new ActionMessages();
            session.setAttribute(org.apache.struts.Globals.MESSAGE_KEY, messages);
        }
        messages.add("org.andromda.bpm4struts.warningmessages", new ActionMessage("maximum.results.fetched.warning", "250"));
    }

}
