// license-header java merge-point
package edu.uoc.tfc.dbmodel.crud;

import org.apache.struts.actions.DispatchAction;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;

public final class ManageFactura extends DispatchAction
{
    public ActionForward execute(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        request.getSession().setAttribute("manageableForm", actionForm);
        return super.execute(mapping, actionForm, request, response);
    }

    public ActionForward create(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.FacturaForm form = (edu.uoc.tfc.dbmodel.crud.FacturaForm)actionForm;

        edu.uoc.tfc.ManageableServiceLocator.instance().getFacturaManageableService().create(
            (StringUtils.isBlank(request.getParameter("codiFactura"))) ? null : form.getCodiFactura()
            , (StringUtils.isBlank(request.getParameter("dataEmissio"))) ? null : form.getDataEmissio()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("partDeLaFactura"))) ? null : form.getPartDeLaFactura()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward read(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.FacturaForm form = (edu.uoc.tfc.dbmodel.crud.FacturaForm)actionForm;

        final java.util.List list = edu.uoc.tfc.ManageableServiceLocator.instance().getFacturaManageableService().read(
            (StringUtils.isBlank(request.getParameter("codiFactura"))) ? null : form.getCodiFactura()
            , (StringUtils.isBlank(request.getParameter("dataEmissio"))) ? null : form.getDataEmissio()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("partDeLaFactura"))) ? null : form.getPartDeLaFactura()
        );
        form.setManageableList(list);

        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final java.util.Map backingLists = edu.uoc.tfc.ManageableServiceLocator.instance().getFacturaManageableService().readBackingLists();
        form.setPartDeLaFacturaBackingList((java.util.List)backingLists.get("partDeLaFactura"));

        return mapping.getInputForward();
    }

    public ActionForward preload(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.FacturaForm form = (edu.uoc.tfc.dbmodel.crud.FacturaForm)actionForm;

        final java.util.List list = edu.uoc.tfc.ManageableServiceLocator.instance().getFacturaManageableService().readAll();
        form.setManageableList(list);


        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final java.util.Map backingLists = edu.uoc.tfc.ManageableServiceLocator.instance().getFacturaManageableService().readBackingLists();
        if (StringUtils.isNotBlank(request.getParameter("ref_Part")))
        {
            form.setPartDeLaFactura(new java.lang.Long(request.getParameter("ref_Part")));
        }
        form.setPartDeLaFacturaBackingList((java.util.List)backingLists.get("partDeLaFactura"));

        return mapping.getInputForward();
    }

    protected ActionForward unspecified(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        return preload(mapping, actionForm, request, response);
    }

    public ActionForward update(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.FacturaForm form = (edu.uoc.tfc.dbmodel.crud.FacturaForm) actionForm;

        edu.uoc.tfc.ManageableServiceLocator.instance().getFacturaManageableService().update(
            (StringUtils.isBlank(request.getParameter("codiFactura"))) ? null : form.getCodiFactura()
            , (StringUtils.isBlank(request.getParameter("dataEmissio"))) ? null : form.getDataEmissio()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("partDeLaFactura"))) ? null : form.getPartDeLaFactura()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward delete(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.FacturaForm form = (edu.uoc.tfc.dbmodel.crud.FacturaForm) actionForm;

        final java.lang.Long[] selectedRows = form.getSelectedRows();
        if (selectedRows != null && selectedRows.length > 0)
        {
            edu.uoc.tfc.ManageableServiceLocator.instance().getFacturaManageableService().delete(selectedRows);
        }

        return preload(mapping, actionForm, request, response);
    }

    private void saveMaxResultsWarning(HttpServletRequest request)
    {
        final HttpSession session = request.getSession();

        ActionMessages messages = (ActionMessages)session.getAttribute(org.apache.struts.Globals.MESSAGE_KEY);
        if (messages == null)
        {
            messages = new ActionMessages();
            session.setAttribute(org.apache.struts.Globals.MESSAGE_KEY, messages);
        }
        messages.add("org.andromda.bpm4struts.warningmessages", new ActionMessage("maximum.results.fetched.warning", "250"));
    }

}
