// license-header java merge-point
package edu.uoc.tfc.dbmodel.crud;

import org.apache.struts.actions.DispatchAction;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;

public final class ManagePart extends DispatchAction
{
    public ActionForward execute(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        request.getSession().setAttribute("manageableForm", actionForm);
        return super.execute(mapping, actionForm, request, response);
    }

    public ActionForward create(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.PartForm form = (edu.uoc.tfc.dbmodel.crud.PartForm)actionForm;

        edu.uoc.tfc.ManageableServiceLocator.instance().getPartManageableService().create(
            (StringUtils.isBlank(request.getParameter("codiPart"))) ? null : form.getCodiPart()
            , (StringUtils.isBlank(request.getParameter("polissa"))) ? null : form.getPolissa()
            , (StringUtils.isBlank(request.getParameter("dataSinistre"))) ? null : form.getDataSinistre()
            , (StringUtils.isBlank(request.getParameter("baseImposable"))) ? null : form.getBaseImposable()
            , (StringUtils.isBlank(request.getParameter("percentatgeIva"))) ? null : form.getPercentatgeIva()
            , (StringUtils.isBlank(request.getParameter("observacions"))) ? null : form.getObservacions()
            , (StringUtils.isBlank(request.getParameter("obert"))) ? null : form.getObert()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("tipusSinistre"))) ? null : form.getTipusSinistre()
            , (StringUtils.isBlank(request.getParameter("facturaDelPart"))) ? null : form.getFacturaDelPart()
            , (StringUtils.isBlank(request.getParameter("client"))) ? null : form.getClient()
            , (StringUtils.isBlank(request.getParameter("asseguradora"))) ? null : form.getAsseguradora()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward read(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.PartForm form = (edu.uoc.tfc.dbmodel.crud.PartForm)actionForm;

        final java.util.List list = edu.uoc.tfc.ManageableServiceLocator.instance().getPartManageableService().read(
            (StringUtils.isBlank(request.getParameter("codiPart"))) ? null : form.getCodiPart()
            , (StringUtils.isBlank(request.getParameter("polissa"))) ? null : form.getPolissa()
            , (StringUtils.isBlank(request.getParameter("dataSinistre"))) ? null : form.getDataSinistre()
            , (StringUtils.isBlank(request.getParameter("baseImposable"))) ? null : form.getBaseImposable()
            , (StringUtils.isBlank(request.getParameter("percentatgeIva"))) ? null : form.getPercentatgeIva()
            , (StringUtils.isBlank(request.getParameter("observacions"))) ? null : form.getObservacions()
            , (StringUtils.isBlank(request.getParameter("obert"))) ? null : form.getObert()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("tipusSinistre"))) ? null : form.getTipusSinistre()
            , (StringUtils.isBlank(request.getParameter("facturaDelPart"))) ? null : form.getFacturaDelPart()
            , (StringUtils.isBlank(request.getParameter("client"))) ? null : form.getClient()
            , (StringUtils.isBlank(request.getParameter("asseguradora"))) ? null : form.getAsseguradora()
        );
        form.setManageableList(list);

        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final java.util.Map backingLists = edu.uoc.tfc.ManageableServiceLocator.instance().getPartManageableService().readBackingLists();
        form.setTipusSinistreBackingList((java.util.List)backingLists.get("tipusSinistre"));
        form.setFacturaDelPartBackingList((java.util.List)backingLists.get("facturaDelPart"));
        form.setClientBackingList((java.util.List)backingLists.get("client"));
        form.setAsseguradoraBackingList((java.util.List)backingLists.get("asseguradora"));

        return mapping.getInputForward();
    }

    public ActionForward preload(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.PartForm form = (edu.uoc.tfc.dbmodel.crud.PartForm)actionForm;

        final java.util.List list = edu.uoc.tfc.ManageableServiceLocator.instance().getPartManageableService().readAll();
        form.setManageableList(list);


        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final java.util.Map backingLists = edu.uoc.tfc.ManageableServiceLocator.instance().getPartManageableService().readBackingLists();
        if (StringUtils.isNotBlank(request.getParameter("ref_TipusSiniestre")))
        {
            form.setTipusSinistre(new java.lang.Long(request.getParameter("ref_TipusSiniestre")));
        }
        form.setTipusSinistreBackingList((java.util.List)backingLists.get("tipusSinistre"));
        if (StringUtils.isNotBlank(request.getParameter("ref_Factura")))
        {
            final java.lang.Long[] array = new java.lang.Long[1];
            array[0] = new java.lang.Long(request.getParameter("ref_Factura"));
            form.setFacturaDelPart(array);
        }
        form.setFacturaDelPartBackingList((java.util.List)backingLists.get("facturaDelPart"));
        if (StringUtils.isNotBlank(request.getParameter("ref_Client")))
        {
            form.setClient(new java.lang.Long(request.getParameter("ref_Client")));
        }
        form.setClientBackingList((java.util.List)backingLists.get("client"));
        if (StringUtils.isNotBlank(request.getParameter("ref_Asseguradora")))
        {
            form.setAsseguradora(new java.lang.Long(request.getParameter("ref_Asseguradora")));
        }
        form.setAsseguradoraBackingList((java.util.List)backingLists.get("asseguradora"));

        return mapping.getInputForward();
    }

    protected ActionForward unspecified(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        return preload(mapping, actionForm, request, response);
    }

    public ActionForward update(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.PartForm form = (edu.uoc.tfc.dbmodel.crud.PartForm) actionForm;

        edu.uoc.tfc.ManageableServiceLocator.instance().getPartManageableService().update(
            (StringUtils.isBlank(request.getParameter("codiPart"))) ? null : form.getCodiPart()
            , (StringUtils.isBlank(request.getParameter("polissa"))) ? null : form.getPolissa()
            , (StringUtils.isBlank(request.getParameter("dataSinistre"))) ? null : form.getDataSinistre()
            , (StringUtils.isBlank(request.getParameter("baseImposable"))) ? null : form.getBaseImposable()
            , (StringUtils.isBlank(request.getParameter("percentatgeIva"))) ? null : form.getPercentatgeIva()
            , (StringUtils.isBlank(request.getParameter("observacions"))) ? null : form.getObservacions()
            , (StringUtils.isBlank(request.getParameter("obert"))) ? null : form.getObert()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("tipusSinistre"))) ? null : form.getTipusSinistre()
            , (StringUtils.isBlank(request.getParameter("facturaDelPart"))) ? null : form.getFacturaDelPart()
            , (StringUtils.isBlank(request.getParameter("client"))) ? null : form.getClient()
            , (StringUtils.isBlank(request.getParameter("asseguradora"))) ? null : form.getAsseguradora()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward delete(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.crud.PartForm form = (edu.uoc.tfc.dbmodel.crud.PartForm) actionForm;

        final java.lang.Long[] selectedRows = form.getSelectedRows();
        if (selectedRows != null && selectedRows.length > 0)
        {
            edu.uoc.tfc.ManageableServiceLocator.instance().getPartManageableService().delete(selectedRows);
        }

        return preload(mapping, actionForm, request, response);
    }

    private void saveMaxResultsWarning(HttpServletRequest request)
    {
        final HttpSession session = request.getSession();

        ActionMessages messages = (ActionMessages)session.getAttribute(org.apache.struts.Globals.MESSAGE_KEY);
        if (messages == null)
        {
            messages = new ActionMessages();
            session.setAttribute(org.apache.struts.Globals.MESSAGE_KEY, messages);
        }
        messages.add("org.andromda.bpm4struts.warningmessages", new ActionMessage("maximum.results.fetched.warning", "250"));
    }

}
