<%@ include file="/taglib-imports.jspf" %>
<tiles:insert definition="main.layout">

    <tiles:put name="title" type="string">
        <bean:message key="asseguradora.page.title"/>
    </tiles:put>

    <tiles:put name="style" type="string">
        <link rel="stylesheet" type="text/css" media="screen" href="<html:rewrite page="/layout/default-manageable.css"/>"></link>
        <link rel="stylesheet" type="text/css" media="all" href="<html:rewrite page="/layout/default-calendar.css"/>"/>
    </tiles:put>

    <tiles:put name="javascript" type="string">
        <script type="text/javascript" src="<html:rewrite action="/calendar"/>"></script>
        <script type="text/javascript">
        //<!--
            function setSelect(multi, form, name, value)
            {
                var select = form.elements[name];
                var options = select.options;

                // for browser compatibility's sake we go through the options ourselves
                for (var i=0; i<options.length; i++)
                {
                    if (multi)
                    {
                        // Array.indexOf is defined in Javascript 1.5, not before
                        options[i].selected = arrayContainsElement(value,options[i].value);
                    }
                    else
                    {
                        if (options[i].value == value)
                        {
                            select.selectedIndex = i;
                            break;
                        }
                    }

                }
            }

            function arrayContainsElement(array, element)
            {
              var containsElement = false;
              for (var i=0; i<array.length && !containsElement; i++) containsElement = (array[i] == element);
              return containsElement;
            }

            function setAction(crud) { document.forms['manageAsseguradoraForm'].elements['crud'].value = crud; }

            function enableUpdate(enabled) { document.getElementById("updateButton").disabled = !enabled; }

            var selectionCount = 0;

            function verifyEnableDelete(checkbox)
            {
                if (checkbox.checked) selectionCount++; else selectionCount--;
                document.getElementById("deleteButton").disabled = (selectionCount < 1);
            }

            function clearFields(form)
            {
                form.reset();
                enableUpdate(false);
                setFields("","",false,"","[]",form);
            }

            function setFields(nom,descripcio,activa,id,parts,form)
            {
                form.elements["nom"].value = nom;
                form.elements["descripcio"].value = descripcio;
                form.elements["activa"].checked = activa;
                form.elements["id"].value = id;
                setSelect(true,form,"parts",parts.substring(1,parts.length-1).split(", "));
            }
        //-->
        </script>
    </tiles:put>

    <tiles:put name="body" type="string">

        <div>
            <h1><bean:message key="asseguradora.page.title"/></h1>
        </div>

        <html:form styleId="manageAsseguradoraForm" action="/Asseguradora/Manage" method="post">
            <input type="hidden" name="crud" value=""/>
            <div id="criteria">
                <c:if test="${!empty manageableForm}">
                    <table>
                        <tr>
                            <td><nobr><bean:message key="asseguradora.nom"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="nom" styleClass="criteriaField" styleId="nom"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="asseguradora.descripcio"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="descripcio" styleClass="criteriaField" styleId="descripcio"/>
                            </td>
                        </tr>
                        <tr>
                            <td><bean:message key="asseguradora.activa"/></td>
                            <td>
                                <html:checkbox name="manageableForm" property="activa" styleClass="criteriaField" styleId="activa"/>
                            </td>
                        </tr>
                    <html:hidden name="manageableForm" property="id"/>
                        <tr>
                            <td>
                                    <html:link action="/Part/Manage"><bean:message key="asseguradora.parts"/></html:link>
                            </td>
                            <td>
                                <c:choose>
                                    <c:when test="${empty manageableForm.partsBackingList}">
                                        <select name="parts" disabled="disabled"/>
                                    </c:when>
                                    <c:otherwise>
                                        <select name="parts" multiple="multiple">
                                            <c:forEach var="valueLabel" items="${manageableForm.partsBackingList}">
                        <option value="${valueLabel[0]}"<collections:contains item="${valueLabel}" array="${manageableForm.parts}"> selected="selected"</collections:contains>>${valueLabel[1]}</option>
                                            </c:forEach>
                                        </select>
                                    </c:otherwise>
                                </c:choose>
                            </td>
                        </tr>
                    </table>

                    <input type="submit" id="readButton" class="button" value="<bean:message key="button.read"/>" onclick="this.form.elements['id'].value='';setAction('read');"/>
                    <input type="submit" id="createButton" class="button" value="<bean:message key="button.create"/>" onclick="setAction('create');"/>
                    <input type="submit" id="deleteButton" class="button" value="<bean:message key="button.delete"/>" disabled="disabled" onclick="setAction('delete');"/>
                    <input type="submit" id="updateButton" class="button" value="<bean:message key="button.update"/>" disabled="disabled" onclick="setAction('update');return validateUpdate();"/>
                    <input type="button" id="clearButton" class="button" value="<bean:message key="button.clear"/>" onclick="clearFields(this.form);"/>
                </c:if>

<div id="entitySwitcher">
    <nobr>
        <bean:message key="select.other.entity"/>
        <select onchange="document.location=this.options[this.selectedIndex].value+'?ref_Asseguradora='+this.form.elements['id'].value;">
            <option selected="selected" value="<html:rewrite page="/Asseguradora/Manage.do"/>"><bean:message key="asseguradora"/></option>
            <option value="<html:rewrite page="/Client/Manage.do"/>"><bean:message key="client"/></option>
            <option value="<html:rewrite page="/Factura/Manage.do"/>"><bean:message key="factura"/></option>
            <option value="<html:rewrite page="/Operation/Manage.do"/>"><bean:message key="operation"/></option>
            <option value="<html:rewrite page="/Part/Manage.do"/>"><bean:message key="part"/></option>
            <option value="<html:rewrite page="/Role/Manage.do"/>"><bean:message key="role"/></option>
            <option value="<html:rewrite page="/TipusSiniestre/Manage.do"/>"><bean:message key="tipus.siniestre"/></option>
            <option value="<html:rewrite page="/User/Manage.do"/>"><bean:message key="user"/></option>
        </select>
    </nobr>
</div>

            </div>

            <div id="manageableList" class="table">
                <c:if test="${!empty manageableForm.manageableList}">
                    <display:table name="${manageableForm.manageableList}" id="row" requestURI="${pageContext.request.requestURI}"
                            requestURIcontext="false"
                            export="true" pagesize="15" sort="list">
                        <display:column media="html" sortable="false">
                            <nobr>
                                <input type="radio" name="_copy" onclick="enableUpdate(true);setFields('<formatting:escape language="javascript">${row.nom}</formatting:escape>','<formatting:escape language="javascript">${row.descripcio}</formatting:escape>',${row.activa},'<formatting:escape language="javascript">${row.id}</formatting:escape>','<formatting:escape language="javascript">${row.parts}</formatting:escape>',this.form);"/>
                                <input type="checkbox" name="selectedRows" value="${row.id}" onclick="verifyEnableDelete(this);"/>
                            </nobr>
                        </display:column>
                        <display:column media="xml csv excel pdf"
                            property="nom"
                            titleKey="asseguradora.nom"/>
                        <display:column media="html"
                            headerClass="nom" paramId="nom" maxLength="36"
                            sortProperty="nom" sortable="true"
                            titleKey="asseguradora.nom"><nobr><formatting:escape language="javascript,html">${row.nom}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="descripcio"
                            titleKey="asseguradora.descripcio"/>
                        <display:column media="html"
                            headerClass="descripcio" paramId="descripcio" maxLength="36"
                            sortProperty="descripcio" sortable="true"
                            titleKey="asseguradora.descripcio"><nobr><formatting:escape language="javascript,html">${row.descripcio}</formatting:escape></nobr></display:column>
                        <display:column media="html" headerClass="activa" titleKey="asseguradora.activa">
                            <c:choose>
                                <c:when test="${row.activa}"><input type="checkbox" checked="checked" disabled="disabled"/></c:when>
                                <c:otherwise><input type="checkbox" disabled="disabled"/></c:otherwise>
                            </c:choose>
                        </display:column>
                        <display:column media="xml csv excel pdf"
                            property="activa" titleKey="asseguradora.activa"/>
                        <display:column media="xml csv excel pdf"
                            property="parts"
                            titleKey="asseguradora.parts"/>
                        <display:column media="html"
                            headerClass="parts" paramId="parts" maxLength="36"
                            sortProperty="parts" sortable="true"
                            titleKey="asseguradora.parts"><nobr><formatting:escape language="javascript,html">${row.parts}</formatting:escape></nobr></display:column>
                    </display:table>
                </c:if>
            </div>

        </html:form>

        <div id="pageHelpSection">
            <blockquote>
                <a href="" id="pageHelp" style="display:inline;" onclick="openWindow('<html:rewrite action="/Asseguradora/ManageHelp"/>','onlinehelp',true,false,760,540); return false;">
                    <bean:message key="online.help.href"/>
                </a>
                <html:img page="/layout/help.gif" style="display:inline;"/>
            </blockquote>
        </div>

    </tiles:put>

</tiles:insert>

