<%@ include file="/taglib-imports.jspf" %>
<tiles:insert definition="main.layout">

    <tiles:put name="title" type="string">
        <bean:message key="client.page.title"/>
    </tiles:put>

    <tiles:put name="style" type="string">
        <link rel="stylesheet" type="text/css" media="screen" href="<html:rewrite page="/layout/default-manageable.css"/>"></link>
        <link rel="stylesheet" type="text/css" media="all" href="<html:rewrite page="/layout/default-calendar.css"/>"/>
    </tiles:put>

    <tiles:put name="javascript" type="string">
        <script type="text/javascript" src="<html:rewrite action="/calendar"/>"></script>
        <script type="text/javascript">
        //<!--
            function setSelect(multi, form, name, value)
            {
                var select = form.elements[name];
                var options = select.options;

                // for browser compatibility's sake we go through the options ourselves
                for (var i=0; i<options.length; i++)
                {
                    if (multi)
                    {
                        // Array.indexOf is defined in Javascript 1.5, not before
                        options[i].selected = arrayContainsElement(value,options[i].value);
                    }
                    else
                    {
                        if (options[i].value == value)
                        {
                            select.selectedIndex = i;
                            break;
                        }
                    }

                }
            }

            function arrayContainsElement(array, element)
            {
              var containsElement = false;
              for (var i=0; i<array.length && !containsElement; i++) containsElement = (array[i] == element);
              return containsElement;
            }

            function setAction(crud) { document.forms['manageClientForm'].elements['crud'].value = crud; }

            function enableUpdate(enabled) { document.getElementById("updateButton").disabled = !enabled; }

            var selectionCount = 0;

            function verifyEnableDelete(checkbox)
            {
                if (checkbox.checked) selectionCount++; else selectionCount--;
                document.getElementById("deleteButton").disabled = (selectionCount < 1);
            }

            function clearFields(form)
            {
                form.reset();
                enableUpdate(false);
                setFields("","","","","","","",false,"","[]",form);
            }

            function setFields(dni,nom,primerCognom,segonCognom,telefon,mail,dataNaixement,actiu,id,partsDelClient,form)
            {
                form.elements["dni"].value = dni;
                form.elements["nom"].value = nom;
                form.elements["primerCognom"].value = primerCognom;
                form.elements["segonCognom"].value = segonCognom;
                form.elements["telefon"].value = telefon;
                form.elements["mail"].value = mail;
                form.elements["dataNaixement"].value = dataNaixement;
                form.elements["actiu"].checked = actiu;
                form.elements["id"].value = id;
                setSelect(true,form,"partsDelClient",partsDelClient.substring(1,partsDelClient.length-1).split(", "));
            }
        //-->
        </script>
    </tiles:put>

    <tiles:put name="body" type="string">

        <div>
            <h1><bean:message key="client.page.title"/></h1>
        </div>

        <html:form styleId="manageClientForm" action="/Client/Manage" method="post">
            <input type="hidden" name="crud" value=""/>
            <div id="criteria">
                <c:if test="${!empty manageableForm}">
                    <table>
                        <tr>
                            <td><nobr><bean:message key="client.dni"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="dni" styleClass="criteriaField" styleId="dni"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="client.nom"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="nom" styleClass="criteriaField" styleId="nom"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="client.primer.cognom"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="primerCognom" styleClass="criteriaField" styleId="primerCognom"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="client.segon.cognom"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="segonCognom" styleClass="criteriaField" styleId="segonCognom"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="client.telefon"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="telefon" styleClass="criteriaField" styleId="telefon"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="client.mail"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="mail" styleClass="criteriaField" styleId="mail"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="client.data.naixement"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="dataNaixement" styleClass="criteriaField" styleId="dataNaixement"/>
                            </td>
                        </tr>
                        <tr>
                            <td><bean:message key="client.actiu"/></td>
                            <td>
                                <html:checkbox name="manageableForm" property="actiu" styleClass="criteriaField" styleId="actiu"/>
                            </td>
                        </tr>
                    <html:hidden name="manageableForm" property="id"/>
                        <tr>
                            <td>
                                    <nobr><html:link action="/Part/Manage"><bean:message key="client.parts.del.client"/></html:link> <div class="important">*</div></nobr>
                            </td>
                            <td>
                                <c:choose>
                                    <c:when test="${empty manageableForm.partsDelClientBackingList}">
                                        <select name="partsDelClient" disabled="disabled"/>
                                    </c:when>
                                    <c:otherwise>
                                        <select name="partsDelClient" multiple="multiple">
                                            <c:forEach var="valueLabel" items="${manageableForm.partsDelClientBackingList}">
                        <option value="${valueLabel[0]}"<collections:contains item="${valueLabel}" array="${manageableForm.partsDelClient}"> selected="selected"</collections:contains>>${valueLabel[1]}</option>
                                            </c:forEach>
                                        </select>
                                    </c:otherwise>
                                </c:choose>
                            </td>
                        </tr>
                    </table>

                    <input type="submit" id="readButton" class="button" value="<bean:message key="button.read"/>" onclick="this.form.elements['id'].value='';setAction('read');"/>
                    <input type="submit" id="createButton" class="button" value="<bean:message key="button.create"/>" onclick="setAction('create');"/>
                    <input type="submit" id="deleteButton" class="button" value="<bean:message key="button.delete"/>" disabled="disabled" onclick="setAction('delete');"/>
                    <input type="submit" id="updateButton" class="button" value="<bean:message key="button.update"/>" disabled="disabled" onclick="setAction('update');return validateUpdate();"/>
                    <input type="button" id="clearButton" class="button" value="<bean:message key="button.clear"/>" onclick="clearFields(this.form);"/>
                </c:if>

<div id="entitySwitcher">
    <nobr>
        <bean:message key="select.other.entity"/>
        <select onchange="document.location=this.options[this.selectedIndex].value+'?ref_Client='+this.form.elements['id'].value;">
            <option value="<html:rewrite page="/Asseguradora/Manage.do"/>"><bean:message key="asseguradora"/></option>
            <option selected="selected" value="<html:rewrite page="/Client/Manage.do"/>"><bean:message key="client"/></option>
            <option value="<html:rewrite page="/Factura/Manage.do"/>"><bean:message key="factura"/></option>
            <option value="<html:rewrite page="/Operation/Manage.do"/>"><bean:message key="operation"/></option>
            <option value="<html:rewrite page="/Part/Manage.do"/>"><bean:message key="part"/></option>
            <option value="<html:rewrite page="/Role/Manage.do"/>"><bean:message key="role"/></option>
            <option value="<html:rewrite page="/TipusSiniestre/Manage.do"/>"><bean:message key="tipus.siniestre"/></option>
            <option value="<html:rewrite page="/User/Manage.do"/>"><bean:message key="user"/></option>
        </select>
    </nobr>
</div>

            </div>

            <div id="manageableList" class="table">
                <c:if test="${!empty manageableForm.manageableList}">
                    <display:table name="${manageableForm.manageableList}" id="row" requestURI="${pageContext.request.requestURI}"
                            requestURIcontext="false"
                            export="true" pagesize="15" sort="list">
                        <display:column media="html" sortable="false">
                            <nobr>
                                <input type="radio" name="_copy" onclick="enableUpdate(true);setFields('<formatting:escape language="javascript">${row.dni}</formatting:escape>','<formatting:escape language="javascript">${row.nom}</formatting:escape>','<formatting:escape language="javascript">${row.primerCognom}</formatting:escape>','<formatting:escape language="javascript">${row.segonCognom}</formatting:escape>','<formatting:escape language="javascript">${row.telefon}</formatting:escape>','<formatting:escape language="javascript">${row.mail}</formatting:escape>','<formatting:escape language="javascript">${row.dataNaixement}</formatting:escape>',${row.actiu},'<formatting:escape language="javascript">${row.id}</formatting:escape>','<formatting:escape language="javascript">${row.partsDelClient}</formatting:escape>',this.form);"/>
                                <input type="checkbox" name="selectedRows" value="${row.id}" onclick="verifyEnableDelete(this);"/>
                            </nobr>
                        </display:column>
                        <display:column media="xml csv excel pdf"
                            property="dni"
                            titleKey="client.dni"/>
                        <display:column media="html"
                            headerClass="dni" paramId="dni" maxLength="36"
                            sortProperty="dni" sortable="true"
                            titleKey="client.dni"><nobr><formatting:escape language="javascript,html">${row.dni}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="nom"
                            titleKey="client.nom"/>
                        <display:column media="html"
                            headerClass="nom" paramId="nom" maxLength="36"
                            sortProperty="nom" sortable="true"
                            titleKey="client.nom"><nobr><formatting:escape language="javascript,html">${row.nom}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="primerCognom"
                            titleKey="client.primer.cognom"/>
                        <display:column media="html"
                            headerClass="primerCognom" paramId="primerCognom" maxLength="36"
                            sortProperty="primerCognom" sortable="true"
                            titleKey="client.primer.cognom"><nobr><formatting:escape language="javascript,html">${row.primerCognom}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="segonCognom"
                            titleKey="client.segon.cognom"/>
                        <display:column media="html"
                            headerClass="segonCognom" paramId="segonCognom" maxLength="36"
                            sortProperty="segonCognom" sortable="true"
                            titleKey="client.segon.cognom"><nobr><formatting:escape language="javascript,html">${row.segonCognom}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="telefon"
                            titleKey="client.telefon"/>
                        <display:column media="html"
                            headerClass="telefon" paramId="telefon" maxLength="36"
                            sortProperty="telefon" sortable="true"
                            titleKey="client.telefon"><nobr><formatting:escape language="javascript,html">${row.telefon}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="mail"
                            titleKey="client.mail"/>
                        <display:column media="html"
                            headerClass="mail" paramId="mail" maxLength="36"
                            sortProperty="mail" sortable="true"
                            titleKey="client.mail"><nobr><formatting:escape language="javascript,html">${row.mail}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="dataNaixement"
                            titleKey="client.data.naixement"/>
                        <display:column media="html"
                            headerClass="dataNaixement" paramId="dataNaixement" maxLength="36"
                            sortProperty="dataNaixement" sortable="true"
                            titleKey="client.data.naixement"><nobr><formatting:escape language="javascript,html">${row.dataNaixement}</formatting:escape></nobr></display:column>
                        <display:column media="html" headerClass="actiu" titleKey="client.actiu">
                            <c:choose>
                                <c:when test="${row.actiu}"><input type="checkbox" checked="checked" disabled="disabled"/></c:when>
                                <c:otherwise><input type="checkbox" disabled="disabled"/></c:otherwise>
                            </c:choose>
                        </display:column>
                        <display:column media="xml csv excel pdf"
                            property="actiu" titleKey="client.actiu"/>
                        <display:column media="xml csv excel pdf"
                            property="partsDelClient"
                            titleKey="client.parts.del.client"/>
                        <display:column media="html"
                            headerClass="partsDelClient" paramId="partsDelClient" maxLength="36"
                            sortProperty="partsDelClient" sortable="true"
                            titleKey="client.parts.del.client"><nobr><formatting:escape language="javascript,html">${row.partsDelClient}</formatting:escape></nobr></display:column>
                    </display:table>
                </c:if>
            </div>

        </html:form>

        <div id="pageHelpSection">
            <blockquote>
                <a href="" id="pageHelp" style="display:inline;" onclick="openWindow('<html:rewrite action="/Client/ManageHelp"/>','onlinehelp',true,false,760,540); return false;">
                    <bean:message key="online.help.href"/>
                </a>
                <html:img page="/layout/help.gif" style="display:inline;"/>
            </blockquote>
        </div>

    </tiles:put>

</tiles:insert>

