<%@ include file="/taglib-imports.jspf" %>
<tiles:insert definition="main.layout">

    <tiles:put name="title" type="string">
        <bean:message key="factura.page.title"/>
    </tiles:put>

    <tiles:put name="style" type="string">
        <link rel="stylesheet" type="text/css" media="screen" href="<html:rewrite page="/layout/default-manageable.css"/>"></link>
        <link rel="stylesheet" type="text/css" media="all" href="<html:rewrite page="/layout/default-calendar.css"/>"/>
    </tiles:put>

    <tiles:put name="javascript" type="string">
        <script type="text/javascript" src="<html:rewrite action="/calendar"/>"></script>
        <script type="text/javascript">
        //<!--
            function setSelect(multi, form, name, value)
            {
                var select = form.elements[name];
                var options = select.options;

                // for browser compatibility's sake we go through the options ourselves
                for (var i=0; i<options.length; i++)
                {
                    if (multi)
                    {
                        // Array.indexOf is defined in Javascript 1.5, not before
                        options[i].selected = arrayContainsElement(value,options[i].value);
                    }
                    else
                    {
                        if (options[i].value == value)
                        {
                            select.selectedIndex = i;
                            break;
                        }
                    }

                }
            }

            function arrayContainsElement(array, element)
            {
              var containsElement = false;
              for (var i=0; i<array.length && !containsElement; i++) containsElement = (array[i] == element);
              return containsElement;
            }

            function setAction(crud) { document.forms['manageFacturaForm'].elements['crud'].value = crud; }

            function enableUpdate(enabled) { document.getElementById("updateButton").disabled = !enabled; }

            var selectionCount = 0;

            function verifyEnableDelete(checkbox)
            {
                if (checkbox.checked) selectionCount++; else selectionCount--;
                document.getElementById("deleteButton").disabled = (selectionCount < 1);
            }

            function clearFields(form)
            {
                form.reset();
                enableUpdate(false);
                setFields("","","","",form);
            }

            function setFields(codiFactura,dataEmissio,id,partDeLaFactura,form)
            {
                form.elements["codiFactura"].value = codiFactura;
                form.elements["dataEmissio"].value = dataEmissio;
                form.elements["id"].value = id;
                setSelect(false,form,"partDeLaFactura",partDeLaFactura);
            }
        //-->
        </script>
    </tiles:put>

    <tiles:put name="body" type="string">

        <div>
            <h1><bean:message key="factura.page.title"/></h1>
        </div>

        <html:form styleId="manageFacturaForm" action="/Factura/Manage" method="post">
            <input type="hidden" name="crud" value=""/>
            <div id="criteria">
                <c:if test="${!empty manageableForm}">
                    <table>
                        <tr>
                            <td><nobr><bean:message key="factura.codi.factura"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="codiFactura" styleClass="criteriaField" styleId="codiFactura"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="factura.data.emissio"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="dataEmissio" styleClass="criteriaField" styleId="dataEmissio"/>
                            </td>
                        </tr>
                    <html:hidden name="manageableForm" property="id"/>
                        <tr>
                            <td>
                                    <nobr><html:link action="/Part/Manage"><bean:message key="factura.part.de.la.factura"/></html:link> <div class="important">*</div></nobr>
                            </td>
                            <td>
                                <c:choose>
                                    <c:when test="${empty manageableForm.partDeLaFacturaBackingList}">
                                        <select name="partDeLaFactura" disabled="disabled"/>
                                    </c:when>
                                    <c:otherwise>
                                        <select name="partDeLaFactura">
                                            <option value=""><bean:message key="select.option.blank"/></option>
                                            <c:forEach var="valueLabel" items="${manageableForm.partDeLaFacturaBackingList}">
                                                <c:choose>
                                                    <c:when test="${valueLabel[0] eq manageableForm.partDeLaFactura}">
                                                        <option value="${valueLabel[0]}" selected="selected">${valueLabel[1]}</option>
                                                    </c:when>
                                                    <c:otherwise>
                                                        <option value="${valueLabel[0]}">${valueLabel[1]}</option>
                                                    </c:otherwise>
                                                </c:choose>
                                            </c:forEach>
                                        </select>
                                    </c:otherwise>
                                </c:choose>
                            </td>
                        </tr>
                    </table>

                    <input type="submit" id="readButton" class="button" value="<bean:message key="button.read"/>" onclick="this.form.elements['id'].value='';setAction('read');"/>
                    <input type="submit" id="createButton" class="button" value="<bean:message key="button.create"/>" onclick="setAction('create');"/>
                    <input type="submit" id="deleteButton" class="button" value="<bean:message key="button.delete"/>" disabled="disabled" onclick="setAction('delete');"/>
                    <input type="submit" id="updateButton" class="button" value="<bean:message key="button.update"/>" disabled="disabled" onclick="setAction('update');return validateUpdate();"/>
                    <input type="button" id="clearButton" class="button" value="<bean:message key="button.clear"/>" onclick="clearFields(this.form);"/>
                </c:if>

<div id="entitySwitcher">
    <nobr>
        <bean:message key="select.other.entity"/>
        <select onchange="document.location=this.options[this.selectedIndex].value+'?ref_Factura='+this.form.elements['id'].value;">
            <option value="<html:rewrite page="/Asseguradora/Manage.do"/>"><bean:message key="asseguradora"/></option>
            <option value="<html:rewrite page="/Client/Manage.do"/>"><bean:message key="client"/></option>
            <option selected="selected" value="<html:rewrite page="/Factura/Manage.do"/>"><bean:message key="factura"/></option>
            <option value="<html:rewrite page="/Operation/Manage.do"/>"><bean:message key="operation"/></option>
            <option value="<html:rewrite page="/Part/Manage.do"/>"><bean:message key="part"/><bean:message key="referencing.entity.marker"/></option>
            <option value="<html:rewrite page="/Role/Manage.do"/>"><bean:message key="role"/></option>
            <option value="<html:rewrite page="/TipusSiniestre/Manage.do"/>"><bean:message key="tipus.siniestre"/></option>
            <option value="<html:rewrite page="/User/Manage.do"/>"><bean:message key="user"/></option>
        </select>
    </nobr>
</div>

            </div>

            <div id="manageableList" class="table">
                <c:if test="${!empty manageableForm.manageableList}">
                    <display:table name="${manageableForm.manageableList}" id="row" requestURI="${pageContext.request.requestURI}"
                            requestURIcontext="false"
                            export="true" pagesize="15" sort="list">
                        <display:column media="html" sortable="false">
                            <nobr>
                                <input type="radio" name="_copy" onclick="enableUpdate(true);setFields('<formatting:escape language="javascript">${row.codiFactura}</formatting:escape>','<formatting:escape language="javascript">${row.dataEmissio}</formatting:escape>','<formatting:escape language="javascript">${row.id}</formatting:escape>','<formatting:escape language="javascript">${row.partDeLaFactura}</formatting:escape>',this.form);"/>
                                <input type="checkbox" name="selectedRows" value="${row.id}" onclick="verifyEnableDelete(this);"/>
                            </nobr>
                        </display:column>
                        <display:column media="xml csv excel pdf"
                            property="codiFactura"
                            titleKey="factura.codi.factura"/>
                        <display:column media="html"
                            headerClass="codiFactura" paramId="codiFactura" maxLength="36"
                            sortProperty="codiFactura" sortable="true"
                            titleKey="factura.codi.factura"><nobr><formatting:escape language="javascript,html">${row.codiFactura}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="dataEmissio"
                            titleKey="factura.data.emissio"/>
                        <display:column media="html"
                            headerClass="dataEmissio" paramId="dataEmissio" maxLength="36"
                            sortProperty="dataEmissio" sortable="true"
                            titleKey="factura.data.emissio"><nobr><formatting:escape language="javascript,html">${row.dataEmissio}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="partDeLaFactura"
                            titleKey="factura.part.de.la.factura"/>
                        <display:column media="html"
                            headerClass="partDeLaFactura" paramId="partDeLaFactura" maxLength="36"
                            sortProperty="partDeLaFactura" sortable="true"
                            titleKey="factura.part.de.la.factura"><nobr><formatting:escape language="javascript,html">${row.partDeLaFactura}</formatting:escape></nobr></display:column>
                    </display:table>
                </c:if>
            </div>

        </html:form>

        <div id="pageHelpSection">
            <blockquote>
                <a href="" id="pageHelp" style="display:inline;" onclick="openWindow('<html:rewrite action="/Factura/ManageHelp"/>','onlinehelp',true,false,760,540); return false;">
                    <bean:message key="online.help.href"/>
                </a>
                <html:img page="/layout/help.gif" style="display:inline;"/>
            </blockquote>
        </div>

    </tiles:put>

</tiles:insert>

