<%@ include file="/taglib-imports.jspf" %>
<tiles:insert definition="main.layout">

    <tiles:put name="title" type="string">
        <bean:message key="part.page.title"/>
    </tiles:put>

    <tiles:put name="style" type="string">
        <link rel="stylesheet" type="text/css" media="screen" href="<html:rewrite page="/layout/default-manageable.css"/>"></link>
        <link rel="stylesheet" type="text/css" media="all" href="<html:rewrite page="/layout/default-calendar.css"/>"/>
    </tiles:put>

    <tiles:put name="javascript" type="string">
        <script type="text/javascript" src="<html:rewrite action="/calendar"/>"></script>
        <script type="text/javascript">
        //<!--
            function setSelect(multi, form, name, value)
            {
                var select = form.elements[name];
                var options = select.options;

                // for browser compatibility's sake we go through the options ourselves
                for (var i=0; i<options.length; i++)
                {
                    if (multi)
                    {
                        // Array.indexOf is defined in Javascript 1.5, not before
                        options[i].selected = arrayContainsElement(value,options[i].value);
                    }
                    else
                    {
                        if (options[i].value == value)
                        {
                            select.selectedIndex = i;
                            break;
                        }
                    }

                }
            }

            function arrayContainsElement(array, element)
            {
              var containsElement = false;
              for (var i=0; i<array.length && !containsElement; i++) containsElement = (array[i] == element);
              return containsElement;
            }

            function setAction(crud) { document.forms['managePartForm'].elements['crud'].value = crud; }

            function enableUpdate(enabled) { document.getElementById("updateButton").disabled = !enabled; }

            var selectionCount = 0;

            function verifyEnableDelete(checkbox)
            {
                if (checkbox.checked) selectionCount++; else selectionCount--;
                document.getElementById("deleteButton").disabled = (selectionCount < 1);
            }

            function clearFields(form)
            {
                form.reset();
                enableUpdate(false);
                setFields("","","","","","",false,"","","[]","","",form);
            }

            function setFields(codiPart,polissa,dataSinistre,baseImposable,percentatgeIva,observacions,obert,id,tipusSinistre,facturaDelPart,client,asseguradora,form)
            {
                form.elements["codiPart"].value = codiPart;
                form.elements["polissa"].value = polissa;
                form.elements["dataSinistre"].value = dataSinistre;
                form.elements["baseImposable"].value = baseImposable;
                form.elements["percentatgeIva"].value = percentatgeIva;
                form.elements["observacions"].value = observacions;
                form.elements["obert"].checked = obert;
                form.elements["id"].value = id;
                setSelect(false,form,"tipusSinistre",tipusSinistre);
                setSelect(true,form,"facturaDelPart",facturaDelPart.substring(1,facturaDelPart.length-1).split(", "));
                setSelect(false,form,"client",client);
                setSelect(false,form,"asseguradora",asseguradora);
            }
        //-->
        </script>
    </tiles:put>

    <tiles:put name="body" type="string">

        <div>
            <h1><bean:message key="part.page.title"/></h1>
        </div>

        <html:form styleId="managePartForm" action="/Part/Manage" method="post">
            <input type="hidden" name="crud" value=""/>
            <div id="criteria">
                <c:if test="${!empty manageableForm}">
                    <table>
                        <tr>
                            <td><nobr><bean:message key="part.codi.part"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="codiPart" styleClass="criteriaField" styleId="codiPart"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="part.polissa"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="polissa" styleClass="criteriaField" styleId="polissa"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="part.data.sinistre"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="dataSinistre" styleClass="criteriaField" styleId="dataSinistre"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="part.base.imposable"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="baseImposable" styleClass="criteriaField" styleId="baseImposable"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="part.percentatge.iva"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="percentatgeIva" styleClass="criteriaField" styleId="percentatgeIva"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="part.observacions"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="observacions" styleClass="criteriaField" styleId="observacions"/>
                            </td>
                        </tr>
                        <tr>
                            <td><bean:message key="part.obert"/></td>
                            <td>
                                <html:checkbox name="manageableForm" property="obert" styleClass="criteriaField" styleId="obert"/>
                            </td>
                        </tr>
                    <html:hidden name="manageableForm" property="id"/>
                        <tr>
                            <td>
                                    <nobr><html:link action="/TipusSiniestre/Manage"><bean:message key="part.tipus.sinistre"/></html:link> <div class="important">*</div></nobr>
                            </td>
                            <td>
                                <c:choose>
                                    <c:when test="${empty manageableForm.tipusSinistreBackingList}">
                                        <select name="tipusSinistre" disabled="disabled"/>
                                    </c:when>
                                    <c:otherwise>
                                        <select name="tipusSinistre">
                                            <option value=""><bean:message key="select.option.blank"/></option>
                                            <c:forEach var="valueLabel" items="${manageableForm.tipusSinistreBackingList}">
                                                <c:choose>
                                                    <c:when test="${valueLabel[0] eq manageableForm.tipusSinistre}">
                                                        <option value="${valueLabel[0]}" selected="selected">${valueLabel[1]}</option>
                                                    </c:when>
                                                    <c:otherwise>
                                                        <option value="${valueLabel[0]}">${valueLabel[1]}</option>
                                                    </c:otherwise>
                                                </c:choose>
                                            </c:forEach>
                                        </select>
                                    </c:otherwise>
                                </c:choose>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                    <nobr><html:link action="/Factura/Manage"><bean:message key="part.factura.del.part"/></html:link> <div class="important">*</div></nobr>
                            </td>
                            <td>
                                <c:choose>
                                    <c:when test="${empty manageableForm.facturaDelPartBackingList}">
                                        <select name="facturaDelPart" disabled="disabled"/>
                                    </c:when>
                                    <c:otherwise>
                                        <select name="facturaDelPart" multiple="multiple">
                                            <c:forEach var="valueLabel" items="${manageableForm.facturaDelPartBackingList}">
                        <option value="${valueLabel[0]}"<collections:contains item="${valueLabel}" array="${manageableForm.facturaDelPart}"> selected="selected"</collections:contains>>${valueLabel[1]}</option>
                                            </c:forEach>
                                        </select>
                                    </c:otherwise>
                                </c:choose>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                    <nobr><html:link action="/Client/Manage"><bean:message key="part.client"/></html:link> <div class="important">*</div></nobr>
                            </td>
                            <td>
                                <c:choose>
                                    <c:when test="${empty manageableForm.clientBackingList}">
                                        <select name="client" disabled="disabled"/>
                                    </c:when>
                                    <c:otherwise>
                                        <select name="client">
                                            <option value=""><bean:message key="select.option.blank"/></option>
                                            <c:forEach var="valueLabel" items="${manageableForm.clientBackingList}">
                                                <c:choose>
                                                    <c:when test="${valueLabel[0] eq manageableForm.client}">
                                                        <option value="${valueLabel[0]}" selected="selected">${valueLabel[1]}</option>
                                                    </c:when>
                                                    <c:otherwise>
                                                        <option value="${valueLabel[0]}">${valueLabel[1]}</option>
                                                    </c:otherwise>
                                                </c:choose>
                                            </c:forEach>
                                        </select>
                                    </c:otherwise>
                                </c:choose>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                    <nobr><html:link action="/Asseguradora/Manage"><bean:message key="part.asseguradora"/></html:link> <div class="important">*</div></nobr>
                            </td>
                            <td>
                                <c:choose>
                                    <c:when test="${empty manageableForm.asseguradoraBackingList}">
                                        <select name="asseguradora" disabled="disabled"/>
                                    </c:when>
                                    <c:otherwise>
                                        <select name="asseguradora">
                                            <option value=""><bean:message key="select.option.blank"/></option>
                                            <c:forEach var="valueLabel" items="${manageableForm.asseguradoraBackingList}">
                                                <c:choose>
                                                    <c:when test="${valueLabel[0] eq manageableForm.asseguradora}">
                                                        <option value="${valueLabel[0]}" selected="selected">${valueLabel[1]}</option>
                                                    </c:when>
                                                    <c:otherwise>
                                                        <option value="${valueLabel[0]}">${valueLabel[1]}</option>
                                                    </c:otherwise>
                                                </c:choose>
                                            </c:forEach>
                                        </select>
                                    </c:otherwise>
                                </c:choose>
                            </td>
                        </tr>
                    </table>

                    <input type="submit" id="readButton" class="button" value="<bean:message key="button.read"/>" onclick="this.form.elements['id'].value='';setAction('read');"/>
                    <input type="submit" id="createButton" class="button" value="<bean:message key="button.create"/>" onclick="setAction('create');"/>
                    <input type="submit" id="deleteButton" class="button" value="<bean:message key="button.delete"/>" disabled="disabled" onclick="setAction('delete');"/>
                    <input type="submit" id="updateButton" class="button" value="<bean:message key="button.update"/>" disabled="disabled" onclick="setAction('update');return validateUpdate();"/>
                    <input type="button" id="clearButton" class="button" value="<bean:message key="button.clear"/>" onclick="clearFields(this.form);"/>
                </c:if>

<div id="entitySwitcher">
    <nobr>
        <bean:message key="select.other.entity"/>
        <select onchange="document.location=this.options[this.selectedIndex].value+'?ref_Part='+this.form.elements['id'].value;">
            <option value="<html:rewrite page="/Asseguradora/Manage.do"/>"><bean:message key="asseguradora"/><bean:message key="referencing.entity.marker"/></option>
            <option value="<html:rewrite page="/Client/Manage.do"/>"><bean:message key="client"/><bean:message key="referencing.entity.marker"/></option>
            <option value="<html:rewrite page="/Factura/Manage.do"/>"><bean:message key="factura"/></option>
            <option value="<html:rewrite page="/Operation/Manage.do"/>"><bean:message key="operation"/></option>
            <option selected="selected" value="<html:rewrite page="/Part/Manage.do"/>"><bean:message key="part"/></option>
            <option value="<html:rewrite page="/Role/Manage.do"/>"><bean:message key="role"/></option>
            <option value="<html:rewrite page="/TipusSiniestre/Manage.do"/>"><bean:message key="tipus.siniestre"/><bean:message key="referencing.entity.marker"/></option>
            <option value="<html:rewrite page="/User/Manage.do"/>"><bean:message key="user"/></option>
        </select>
    </nobr>
</div>

            </div>

            <div id="manageableList" class="table">
                <c:if test="${!empty manageableForm.manageableList}">
                    <display:table name="${manageableForm.manageableList}" id="row" requestURI="${pageContext.request.requestURI}"
                            requestURIcontext="false"
                            export="true" pagesize="15" sort="list">
                        <display:column media="html" sortable="false">
                            <nobr>
                                <input type="radio" name="_copy" onclick="enableUpdate(true);setFields('<formatting:escape language="javascript">${row.codiPart}</formatting:escape>','<formatting:escape language="javascript">${row.polissa}</formatting:escape>','<formatting:escape language="javascript">${row.dataSinistre}</formatting:escape>','<formatting:escape language="javascript">${row.baseImposable}</formatting:escape>','<formatting:escape language="javascript">${row.percentatgeIva}</formatting:escape>','<formatting:escape language="javascript">${row.observacions}</formatting:escape>',${row.obert},'<formatting:escape language="javascript">${row.id}</formatting:escape>','<formatting:escape language="javascript">${row.tipusSinistre}</formatting:escape>','<formatting:escape language="javascript">${row.facturaDelPart}</formatting:escape>','<formatting:escape language="javascript">${row.client}</formatting:escape>','<formatting:escape language="javascript">${row.asseguradora}</formatting:escape>',this.form);"/>
                                <input type="checkbox" name="selectedRows" value="${row.id}" onclick="verifyEnableDelete(this);"/>
                            </nobr>
                        </display:column>
                        <display:column media="xml csv excel pdf"
                            property="codiPart"
                            titleKey="part.codi.part"/>
                        <display:column media="html"
                            headerClass="codiPart" paramId="codiPart" maxLength="36"
                            sortProperty="codiPart" sortable="true"
                            titleKey="part.codi.part"><nobr><formatting:escape language="javascript,html">${row.codiPart}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="polissa"
                            titleKey="part.polissa"/>
                        <display:column media="html"
                            headerClass="polissa" paramId="polissa" maxLength="36"
                            sortProperty="polissa" sortable="true"
                            titleKey="part.polissa"><nobr><formatting:escape language="javascript,html">${row.polissa}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="dataSinistre"
                            titleKey="part.data.sinistre"/>
                        <display:column media="html"
                            headerClass="dataSinistre" paramId="dataSinistre" maxLength="36"
                            sortProperty="dataSinistre" sortable="true"
                            titleKey="part.data.sinistre"><nobr><formatting:escape language="javascript,html">${row.dataSinistre}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="baseImposable"
                            titleKey="part.base.imposable"/>
                        <display:column media="html"
                            headerClass="baseImposable" paramId="baseImposable" maxLength="36"
                            sortProperty="baseImposable" sortable="true"
                            titleKey="part.base.imposable"><nobr><formatting:escape language="javascript,html">${row.baseImposable}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="percentatgeIva"
                            titleKey="part.percentatge.iva"/>
                        <display:column media="html"
                            headerClass="percentatgeIva" paramId="percentatgeIva" maxLength="36"
                            sortProperty="percentatgeIva" sortable="true"
                            titleKey="part.percentatge.iva"><nobr><formatting:escape language="javascript,html">${row.percentatgeIva}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="observacions"
                            titleKey="part.observacions"/>
                        <display:column media="html"
                            headerClass="observacions" paramId="observacions" maxLength="36"
                            sortProperty="observacions" sortable="true"
                            titleKey="part.observacions"><nobr><formatting:escape language="javascript,html">${row.observacions}</formatting:escape></nobr></display:column>
                        <display:column media="html" headerClass="obert" titleKey="part.obert">
                            <c:choose>
                                <c:when test="${row.obert}"><input type="checkbox" checked="checked" disabled="disabled"/></c:when>
                                <c:otherwise><input type="checkbox" disabled="disabled"/></c:otherwise>
                            </c:choose>
                        </display:column>
                        <display:column media="xml csv excel pdf"
                            property="obert" titleKey="part.obert"/>
                        <display:column media="xml csv excel pdf"
                            property="tipusSinistre"
                            titleKey="part.tipus.sinistre"/>
                        <display:column media="html"
                            headerClass="tipusSinistre" paramId="tipusSinistre" maxLength="36"
                            sortProperty="tipusSinistre" sortable="true"
                            titleKey="part.tipus.sinistre"><nobr><formatting:escape language="javascript,html">${row.tipusSinistre}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="facturaDelPart"
                            titleKey="part.factura.del.part"/>
                        <display:column media="html"
                            headerClass="facturaDelPart" paramId="facturaDelPart" maxLength="36"
                            sortProperty="facturaDelPart" sortable="true"
                            titleKey="part.factura.del.part"><nobr><formatting:escape language="javascript,html">${row.facturaDelPart}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="client"
                            titleKey="part.client"/>
                        <display:column media="html"
                            headerClass="client" paramId="client" maxLength="36"
                            sortProperty="client" sortable="true"
                            titleKey="part.client"><nobr><formatting:escape language="javascript,html">${row.client}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="asseguradora"
                            titleKey="part.asseguradora"/>
                        <display:column media="html"
                            headerClass="asseguradora" paramId="asseguradora" maxLength="36"
                            sortProperty="asseguradora" sortable="true"
                            titleKey="part.asseguradora"><nobr><formatting:escape language="javascript,html">${row.asseguradora}</formatting:escape></nobr></display:column>
                    </display:table>
                </c:if>
            </div>

        </html:form>

        <div id="pageHelpSection">
            <blockquote>
                <a href="" id="pageHelp" style="display:inline;" onclick="openWindow('<html:rewrite action="/Part/ManageHelp"/>','onlinehelp',true,false,760,540); return false;">
                    <bean:message key="online.help.href"/>
                </a>
                <html:img page="/layout/help.gif" style="display:inline;"/>
            </blockquote>
        </div>

    </tiles:put>

</tiles:insert>

