// license-header java merge-point
package edu.uoc.tfc.dbmodel.security.crud;

import org.apache.struts.actions.DispatchAction;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;

public final class ManageUser extends DispatchAction
{
    public ActionForward execute(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        request.getSession().setAttribute("manageableForm", actionForm);
        return super.execute(mapping, actionForm, request, response);
    }

    public ActionForward create(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.security.crud.UserForm form = (edu.uoc.tfc.dbmodel.security.crud.UserForm)actionForm;

        edu.uoc.tfc.ManageableServiceLocator.instance().getUserManageableService().create(
            (StringUtils.isBlank(request.getParameter("userId"))) ? null : form.getUserId()
            , (StringUtils.isBlank(request.getParameter("password"))) ? null : form.getPassword()
            , (StringUtils.isBlank(request.getParameter("adress"))) ? null : form.getAdress()
            , (StringUtils.isBlank(request.getParameter("active"))) ? null : form.getActive()
            , (StringUtils.isBlank(request.getParameter("nom"))) ? null : form.getNom()
            , (StringUtils.isBlank(request.getParameter("primerCognom"))) ? null : form.getPrimerCognom()
            , (StringUtils.isBlank(request.getParameter("segonCognom"))) ? null : form.getSegonCognom()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("rol"))) ? null : form.getRol()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward read(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.security.crud.UserForm form = (edu.uoc.tfc.dbmodel.security.crud.UserForm)actionForm;

        final java.util.List list = edu.uoc.tfc.ManageableServiceLocator.instance().getUserManageableService().read(
            (StringUtils.isBlank(request.getParameter("userId"))) ? null : form.getUserId()
            , (StringUtils.isBlank(request.getParameter("password"))) ? null : form.getPassword()
            , (StringUtils.isBlank(request.getParameter("adress"))) ? null : form.getAdress()
            , (StringUtils.isBlank(request.getParameter("active"))) ? null : form.getActive()
            , (StringUtils.isBlank(request.getParameter("nom"))) ? null : form.getNom()
            , (StringUtils.isBlank(request.getParameter("primerCognom"))) ? null : form.getPrimerCognom()
            , (StringUtils.isBlank(request.getParameter("segonCognom"))) ? null : form.getSegonCognom()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("rol"))) ? null : form.getRol()
        );
        form.setManageableList(list);

        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final java.util.Map backingLists = edu.uoc.tfc.ManageableServiceLocator.instance().getUserManageableService().readBackingLists();
        form.setRolBackingList((java.util.List)backingLists.get("rol"));

        return mapping.getInputForward();
    }

    public ActionForward preload(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.security.crud.UserForm form = (edu.uoc.tfc.dbmodel.security.crud.UserForm)actionForm;

        final java.util.List list = edu.uoc.tfc.ManageableServiceLocator.instance().getUserManageableService().readAll();
        form.setManageableList(list);


        if (list.size() >= 250)
        {
            saveMaxResultsWarning(request);
        }

        final java.util.Map backingLists = edu.uoc.tfc.ManageableServiceLocator.instance().getUserManageableService().readBackingLists();
        if (StringUtils.isNotBlank(request.getParameter("ref_Role")))
        {
            form.setRol(new java.lang.Long(request.getParameter("ref_Role")));
        }
        form.setRolBackingList((java.util.List)backingLists.get("rol"));

        return mapping.getInputForward();
    }

    protected ActionForward unspecified(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        return preload(mapping, actionForm, request, response);
    }

    public ActionForward update(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.security.crud.UserForm form = (edu.uoc.tfc.dbmodel.security.crud.UserForm) actionForm;

        edu.uoc.tfc.ManageableServiceLocator.instance().getUserManageableService().update(
            (StringUtils.isBlank(request.getParameter("userId"))) ? null : form.getUserId()
            , (StringUtils.isBlank(request.getParameter("password"))) ? null : form.getPassword()
            , (StringUtils.isBlank(request.getParameter("adress"))) ? null : form.getAdress()
            , (StringUtils.isBlank(request.getParameter("active"))) ? null : form.getActive()
            , (StringUtils.isBlank(request.getParameter("nom"))) ? null : form.getNom()
            , (StringUtils.isBlank(request.getParameter("primerCognom"))) ? null : form.getPrimerCognom()
            , (StringUtils.isBlank(request.getParameter("segonCognom"))) ? null : form.getSegonCognom()
            , (StringUtils.isBlank(request.getParameter("id"))) ? null : form.getId()
            , (StringUtils.isBlank(request.getParameter("rol"))) ? null : form.getRol()
        );

        return preload(mapping, actionForm, request, response);
    }

    public ActionForward delete(ActionMapping mapping, ActionForm actionForm, HttpServletRequest request, HttpServletResponse response) throws Exception
    {
        final edu.uoc.tfc.dbmodel.security.crud.UserForm form = (edu.uoc.tfc.dbmodel.security.crud.UserForm) actionForm;

        final java.lang.Long[] selectedRows = form.getSelectedRows();
        if (selectedRows != null && selectedRows.length > 0)
        {
            edu.uoc.tfc.ManageableServiceLocator.instance().getUserManageableService().delete(selectedRows);
        }

        return preload(mapping, actionForm, request, response);
    }

    private void saveMaxResultsWarning(HttpServletRequest request)
    {
        final HttpSession session = request.getSession();

        ActionMessages messages = (ActionMessages)session.getAttribute(org.apache.struts.Globals.MESSAGE_KEY);
        if (messages == null)
        {
            messages = new ActionMessages();
            session.setAttribute(org.apache.struts.Globals.MESSAGE_KEY, messages);
        }
        messages.add("org.andromda.bpm4struts.warningmessages", new ActionMessage("maximum.results.fetched.warning", "250"));
    }

}
