<%@ include file="/taglib-imports.jspf" %>
<tiles:insert definition="main.layout">

    <tiles:put name="title" type="string">
        <bean:message key="role.page.title"/>
    </tiles:put>

    <tiles:put name="style" type="string">
        <link rel="stylesheet" type="text/css" media="screen" href="<html:rewrite page="/layout/default-manageable.css"/>"></link>
        <link rel="stylesheet" type="text/css" media="all" href="<html:rewrite page="/layout/default-calendar.css"/>"/>
    </tiles:put>

    <tiles:put name="javascript" type="string">
        <script type="text/javascript" src="<html:rewrite action="/calendar"/>"></script>
        <script type="text/javascript">
        //<!--
            function setSelect(multi, form, name, value)
            {
                var select = form.elements[name];
                var options = select.options;

                // for browser compatibility's sake we go through the options ourselves
                for (var i=0; i<options.length; i++)
                {
                    if (multi)
                    {
                        // Array.indexOf is defined in Javascript 1.5, not before
                        options[i].selected = arrayContainsElement(value,options[i].value);
                    }
                    else
                    {
                        if (options[i].value == value)
                        {
                            select.selectedIndex = i;
                            break;
                        }
                    }

                }
            }

            function arrayContainsElement(array, element)
            {
              var containsElement = false;
              for (var i=0; i<array.length && !containsElement; i++) containsElement = (array[i] == element);
              return containsElement;
            }

            function setAction(crud) { document.forms['manageRoleForm'].elements['crud'].value = crud; }

            function enableUpdate(enabled) { document.getElementById("updateButton").disabled = !enabled; }

            var selectionCount = 0;

            function verifyEnableDelete(checkbox)
            {
                if (checkbox.checked) selectionCount++; else selectionCount--;
                document.getElementById("deleteButton").disabled = (selectionCount < 1);
            }

            function clearFields(form)
            {
                form.reset();
                enableUpdate(false);
                setFields("","","","[]","[]",form);
            }

            function setFields(roleId,description,id,users,operations,form)
            {
                form.elements["roleId"].value = roleId;
                form.elements["description"].value = description;
                form.elements["id"].value = id;
                setSelect(true,form,"users",users.substring(1,users.length-1).split(", "));
                setSelect(true,form,"operations",operations.substring(1,operations.length-1).split(", "));
            }
        //-->
        </script>
    </tiles:put>

    <tiles:put name="body" type="string">

        <div>
            <h1><bean:message key="role.page.title"/></h1>
        </div>

        <html:form styleId="manageRoleForm" action="/Role/Manage" method="post">
            <input type="hidden" name="crud" value=""/>
            <div id="criteria">
                <c:if test="${!empty manageableForm}">
                    <table>
                        <tr>
                            <td><nobr><bean:message key="role.role.id"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="roleId" styleClass="criteriaField" styleId="roleId"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="role.description"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="description" styleClass="criteriaField" styleId="description"/>
                            </td>
                        </tr>
                    <html:hidden name="manageableForm" property="id"/>
                        <tr>
                            <td>
                                    <html:link action="/User/Manage"><bean:message key="role.users"/></html:link>
                            </td>
                            <td>
                                <c:choose>
                                    <c:when test="${empty manageableForm.usersBackingList}">
                                        <select name="users" disabled="disabled"/>
                                    </c:when>
                                    <c:otherwise>
                                        <select name="users" multiple="multiple">
                                            <c:forEach var="valueLabel" items="${manageableForm.usersBackingList}">
                        <option value="${valueLabel[0]}"<collections:contains item="${valueLabel}" array="${manageableForm.users}"> selected="selected"</collections:contains>>${valueLabel[1]}</option>
                                            </c:forEach>
                                        </select>
                                    </c:otherwise>
                                </c:choose>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                    <html:link action="/Operation/Manage"><bean:message key="role.operations"/></html:link>
                            </td>
                            <td>
                                <c:choose>
                                    <c:when test="${empty manageableForm.operationsBackingList}">
                                        <select name="operations" disabled="disabled"/>
                                    </c:when>
                                    <c:otherwise>
                                        <select name="operations" multiple="multiple">
                                            <c:forEach var="valueLabel" items="${manageableForm.operationsBackingList}">
                        <option value="${valueLabel[0]}"<collections:contains item="${valueLabel}" array="${manageableForm.operations}"> selected="selected"</collections:contains>>${valueLabel[1]}</option>
                                            </c:forEach>
                                        </select>
                                    </c:otherwise>
                                </c:choose>
                            </td>
                        </tr>
                    </table>

                    <input type="submit" id="readButton" class="button" value="<bean:message key="button.read"/>" onclick="this.form.elements['id'].value='';setAction('read');"/>
                    <input type="submit" id="createButton" class="button" value="<bean:message key="button.create"/>" onclick="setAction('create');"/>
                    <input type="submit" id="deleteButton" class="button" value="<bean:message key="button.delete"/>" disabled="disabled" onclick="setAction('delete');"/>
                    <input type="submit" id="updateButton" class="button" value="<bean:message key="button.update"/>" disabled="disabled" onclick="setAction('update');return validateUpdate();"/>
                    <input type="button" id="clearButton" class="button" value="<bean:message key="button.clear"/>" onclick="clearFields(this.form);"/>
                </c:if>

<div id="entitySwitcher">
    <nobr>
        <bean:message key="select.other.entity"/>
        <select onchange="document.location=this.options[this.selectedIndex].value+'?ref_Role='+this.form.elements['id'].value;">
            <option value="<html:rewrite page="/Asseguradora/Manage.do"/>"><bean:message key="asseguradora"/></option>
            <option value="<html:rewrite page="/Client/Manage.do"/>"><bean:message key="client"/></option>
            <option value="<html:rewrite page="/Factura/Manage.do"/>"><bean:message key="factura"/></option>
            <option value="<html:rewrite page="/Operation/Manage.do"/>"><bean:message key="operation"/><bean:message key="referencing.entity.marker"/></option>
            <option value="<html:rewrite page="/Part/Manage.do"/>"><bean:message key="part"/></option>
            <option selected="selected" value="<html:rewrite page="/Role/Manage.do"/>"><bean:message key="role"/></option>
            <option value="<html:rewrite page="/TipusSiniestre/Manage.do"/>"><bean:message key="tipus.siniestre"/></option>
            <option value="<html:rewrite page="/User/Manage.do"/>"><bean:message key="user"/></option>
        </select>
    </nobr>
</div>

            </div>

            <div id="manageableList" class="table">
                <c:if test="${!empty manageableForm.manageableList}">
                    <display:table name="${manageableForm.manageableList}" id="row" requestURI="${pageContext.request.requestURI}"
                            requestURIcontext="false"
                            export="true" pagesize="15" sort="list">
                        <display:column media="html" sortable="false">
                            <nobr>
                                <input type="radio" name="_copy" onclick="enableUpdate(true);setFields('<formatting:escape language="javascript">${row.roleId}</formatting:escape>','<formatting:escape language="javascript">${row.description}</formatting:escape>','<formatting:escape language="javascript">${row.id}</formatting:escape>','<formatting:escape language="javascript">${row.users}</formatting:escape>','<formatting:escape language="javascript">${row.operations}</formatting:escape>',this.form);"/>
                                <input type="checkbox" name="selectedRows" value="${row.id}" onclick="verifyEnableDelete(this);"/>
                            </nobr>
                        </display:column>
                        <display:column media="xml csv excel pdf"
                            property="roleId"
                            titleKey="role.role.id"/>
                        <display:column media="html"
                            headerClass="roleId" paramId="roleId" maxLength="36"
                            sortProperty="roleId" sortable="true"
                            titleKey="role.role.id"><nobr><formatting:escape language="javascript,html">${row.roleId}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="description"
                            titleKey="role.description"/>
                        <display:column media="html"
                            headerClass="description" paramId="description" maxLength="36"
                            sortProperty="description" sortable="true"
                            titleKey="role.description"><nobr><formatting:escape language="javascript,html">${row.description}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="users"
                            titleKey="role.users"/>
                        <display:column media="html"
                            headerClass="users" paramId="users" maxLength="36"
                            sortProperty="users" sortable="true"
                            titleKey="role.users"><nobr><formatting:escape language="javascript,html">${row.users}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="operations"
                            titleKey="role.operations"/>
                        <display:column media="html"
                            headerClass="operations" paramId="operations" maxLength="36"
                            sortProperty="operations" sortable="true"
                            titleKey="role.operations"><nobr><formatting:escape language="javascript,html">${row.operations}</formatting:escape></nobr></display:column>
                    </display:table>
                </c:if>
            </div>

        </html:form>

        <div id="pageHelpSection">
            <blockquote>
                <a href="" id="pageHelp" style="display:inline;" onclick="openWindow('<html:rewrite action="/Role/ManageHelp"/>','onlinehelp',true,false,760,540); return false;">
                    <bean:message key="online.help.href"/>
                </a>
                <html:img page="/layout/help.gif" style="display:inline;"/>
            </blockquote>
        </div>

    </tiles:put>

</tiles:insert>

