<%@ include file="/taglib-imports.jspf" %>
<tiles:insert definition="main.layout">

    <tiles:put name="title" type="string">
        <bean:message key="user.page.title"/>
    </tiles:put>

    <tiles:put name="style" type="string">
        <link rel="stylesheet" type="text/css" media="screen" href="<html:rewrite page="/layout/default-manageable.css"/>"></link>
        <link rel="stylesheet" type="text/css" media="all" href="<html:rewrite page="/layout/default-calendar.css"/>"/>
    </tiles:put>

    <tiles:put name="javascript" type="string">
        <script type="text/javascript" src="<html:rewrite action="/calendar"/>"></script>
        <script type="text/javascript">
        //<!--
            function setSelect(multi, form, name, value)
            {
                var select = form.elements[name];
                var options = select.options;

                // for browser compatibility's sake we go through the options ourselves
                for (var i=0; i<options.length; i++)
                {
                    if (multi)
                    {
                        // Array.indexOf is defined in Javascript 1.5, not before
                        options[i].selected = arrayContainsElement(value,options[i].value);
                    }
                    else
                    {
                        if (options[i].value == value)
                        {
                            select.selectedIndex = i;
                            break;
                        }
                    }

                }
            }

            function arrayContainsElement(array, element)
            {
              var containsElement = false;
              for (var i=0; i<array.length && !containsElement; i++) containsElement = (array[i] == element);
              return containsElement;
            }

            function setAction(crud) { document.forms['manageUserForm'].elements['crud'].value = crud; }

            function enableUpdate(enabled) { document.getElementById("updateButton").disabled = !enabled; }

            var selectionCount = 0;

            function verifyEnableDelete(checkbox)
            {
                if (checkbox.checked) selectionCount++; else selectionCount--;
                document.getElementById("deleteButton").disabled = (selectionCount < 1);
            }

            function clearFields(form)
            {
                form.reset();
                enableUpdate(false);
                setFields("","","",false,"","","","","",form);
            }

            function setFields(userId,password,adress,active,nom,primerCognom,segonCognom,id,rol,form)
            {
                form.elements["userId"].value = userId;
                form.elements["password"].value = password;
                form.elements["adress"].value = adress;
                form.elements["active"].checked = active;
                form.elements["nom"].value = nom;
                form.elements["primerCognom"].value = primerCognom;
                form.elements["segonCognom"].value = segonCognom;
                form.elements["id"].value = id;
                setSelect(false,form,"rol",rol);
            }
        //-->
        </script>
    </tiles:put>

    <tiles:put name="body" type="string">

        <div>
            <h1><bean:message key="user.page.title"/></h1>
        </div>

        <html:form styleId="manageUserForm" action="/User/Manage" method="post">
            <input type="hidden" name="crud" value=""/>
            <div id="criteria">
                <c:if test="${!empty manageableForm}">
                    <table>
                        <tr>
                            <td><nobr><bean:message key="user.user.id"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="userId" styleClass="criteriaField" styleId="userId"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="user.password"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="password" styleClass="criteriaField" styleId="password"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="user.adress"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="adress" styleClass="criteriaField" styleId="adress"/>
                            </td>
                        </tr>
                        <tr>
                            <td><bean:message key="user.active"/></td>
                            <td>
                                <html:checkbox name="manageableForm" property="active" styleClass="criteriaField" styleId="active"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="user.nom"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="nom" styleClass="criteriaField" styleId="nom"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="user.primer.cognom"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="primerCognom" styleClass="criteriaField" styleId="primerCognom"/>
                            </td>
                        </tr>
                        <tr>
                            <td><nobr><bean:message key="user.segon.cognom"/> <div class="important">*</div></nobr></td>
                            <td>
                                <html:text name="manageableForm" property="segonCognom" styleClass="criteriaField" styleId="segonCognom"/>
                            </td>
                        </tr>
                    <html:hidden name="manageableForm" property="id"/>
                        <tr>
                            <td>
                                    <nobr><html:link action="/Role/Manage"><bean:message key="user.rol"/></html:link> <div class="important">*</div></nobr>
                            </td>
                            <td>
                                <c:choose>
                                    <c:when test="${empty manageableForm.rolBackingList}">
                                        <select name="rol" disabled="disabled"/>
                                    </c:when>
                                    <c:otherwise>
                                        <select name="rol">
                                            <option value=""><bean:message key="select.option.blank"/></option>
                                            <c:forEach var="valueLabel" items="${manageableForm.rolBackingList}">
                                                <c:choose>
                                                    <c:when test="${valueLabel[0] eq manageableForm.rol}">
                                                        <option value="${valueLabel[0]}" selected="selected">${valueLabel[1]}</option>
                                                    </c:when>
                                                    <c:otherwise>
                                                        <option value="${valueLabel[0]}">${valueLabel[1]}</option>
                                                    </c:otherwise>
                                                </c:choose>
                                            </c:forEach>
                                        </select>
                                    </c:otherwise>
                                </c:choose>
                            </td>
                        </tr>
                    </table>

                    <input type="submit" id="readButton" class="button" value="<bean:message key="button.read"/>" onclick="this.form.elements['id'].value='';setAction('read');"/>
                    <input type="submit" id="createButton" class="button" value="<bean:message key="button.create"/>" onclick="setAction('create');"/>
                    <input type="submit" id="deleteButton" class="button" value="<bean:message key="button.delete"/>" disabled="disabled" onclick="setAction('delete');"/>
                    <input type="submit" id="updateButton" class="button" value="<bean:message key="button.update"/>" disabled="disabled" onclick="setAction('update');return validateUpdate();"/>
                    <input type="button" id="clearButton" class="button" value="<bean:message key="button.clear"/>" onclick="clearFields(this.form);"/>
                </c:if>

<div id="entitySwitcher">
    <nobr>
        <bean:message key="select.other.entity"/>
        <select onchange="document.location=this.options[this.selectedIndex].value+'?ref_User='+this.form.elements['id'].value;">
            <option value="<html:rewrite page="/Asseguradora/Manage.do"/>"><bean:message key="asseguradora"/></option>
            <option value="<html:rewrite page="/Client/Manage.do"/>"><bean:message key="client"/></option>
            <option value="<html:rewrite page="/Factura/Manage.do"/>"><bean:message key="factura"/></option>
            <option value="<html:rewrite page="/Operation/Manage.do"/>"><bean:message key="operation"/></option>
            <option value="<html:rewrite page="/Part/Manage.do"/>"><bean:message key="part"/></option>
            <option value="<html:rewrite page="/Role/Manage.do"/>"><bean:message key="role"/><bean:message key="referencing.entity.marker"/></option>
            <option value="<html:rewrite page="/TipusSiniestre/Manage.do"/>"><bean:message key="tipus.siniestre"/></option>
            <option selected="selected" value="<html:rewrite page="/User/Manage.do"/>"><bean:message key="user"/></option>
        </select>
    </nobr>
</div>

            </div>

            <div id="manageableList" class="table">
                <c:if test="${!empty manageableForm.manageableList}">
                    <display:table name="${manageableForm.manageableList}" id="row" requestURI="${pageContext.request.requestURI}"
                            requestURIcontext="false"
                            export="true" pagesize="15" sort="list">
                        <display:column media="html" sortable="false">
                            <nobr>
                                <input type="radio" name="_copy" onclick="enableUpdate(true);setFields('<formatting:escape language="javascript">${row.userId}</formatting:escape>','<formatting:escape language="javascript">${row.password}</formatting:escape>','<formatting:escape language="javascript">${row.adress}</formatting:escape>',${row.active},'<formatting:escape language="javascript">${row.nom}</formatting:escape>','<formatting:escape language="javascript">${row.primerCognom}</formatting:escape>','<formatting:escape language="javascript">${row.segonCognom}</formatting:escape>','<formatting:escape language="javascript">${row.id}</formatting:escape>','<formatting:escape language="javascript">${row.rol}</formatting:escape>',this.form);"/>
                                <input type="checkbox" name="selectedRows" value="${row.id}" onclick="verifyEnableDelete(this);"/>
                            </nobr>
                        </display:column>
                        <display:column media="xml csv excel pdf"
                            property="userId"
                            titleKey="user.user.id"/>
                        <display:column media="html"
                            headerClass="userId" paramId="userId" maxLength="36"
                            sortProperty="userId" sortable="true"
                            titleKey="user.user.id"><nobr><formatting:escape language="javascript,html">${row.userId}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="password"
                            titleKey="user.password"/>
                        <display:column media="html"
                            headerClass="password" paramId="password" maxLength="36"
                            sortProperty="password" sortable="true"
                            titleKey="user.password"><nobr><formatting:escape language="javascript,html">${row.password}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="adress"
                            titleKey="user.adress"/>
                        <display:column media="html"
                            headerClass="adress" paramId="adress" maxLength="36"
                            sortProperty="adress" sortable="true"
                            titleKey="user.adress"><nobr><formatting:escape language="javascript,html">${row.adress}</formatting:escape></nobr></display:column>
                        <display:column media="html" headerClass="active" titleKey="user.active">
                            <c:choose>
                                <c:when test="${row.active}"><input type="checkbox" checked="checked" disabled="disabled"/></c:when>
                                <c:otherwise><input type="checkbox" disabled="disabled"/></c:otherwise>
                            </c:choose>
                        </display:column>
                        <display:column media="xml csv excel pdf"
                            property="active" titleKey="user.active"/>
                        <display:column media="xml csv excel pdf"
                            property="nom"
                            titleKey="user.nom"/>
                        <display:column media="html"
                            headerClass="nom" paramId="nom" maxLength="36"
                            sortProperty="nom" sortable="true"
                            titleKey="user.nom"><nobr><formatting:escape language="javascript,html">${row.nom}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="primerCognom"
                            titleKey="user.primer.cognom"/>
                        <display:column media="html"
                            headerClass="primerCognom" paramId="primerCognom" maxLength="36"
                            sortProperty="primerCognom" sortable="true"
                            titleKey="user.primer.cognom"><nobr><formatting:escape language="javascript,html">${row.primerCognom}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="segonCognom"
                            titleKey="user.segon.cognom"/>
                        <display:column media="html"
                            headerClass="segonCognom" paramId="segonCognom" maxLength="36"
                            sortProperty="segonCognom" sortable="true"
                            titleKey="user.segon.cognom"><nobr><formatting:escape language="javascript,html">${row.segonCognom}</formatting:escape></nobr></display:column>
                        <display:column media="xml csv excel pdf"
                            property="rol"
                            titleKey="user.rol"/>
                        <display:column media="html"
                            headerClass="rol" paramId="rol" maxLength="36"
                            sortProperty="rol" sortable="true"
                            titleKey="user.rol"><nobr><formatting:escape language="javascript,html">${row.rol}</formatting:escape></nobr></display:column>
                    </display:table>
                </c:if>
            </div>

        </html:form>

        <div id="pageHelpSection">
            <blockquote>
                <a href="" id="pageHelp" style="display:inline;" onclick="openWindow('<html:rewrite action="/User/ManageHelp"/>','onlinehelp',true,false,760,540); return false;">
                    <bean:message key="online.help.href"/>
                </a>
                <html:img page="/layout/help.gif" style="display:inline;"/>
            </blockquote>
        </div>

    </tiles:put>

</tiles:insert>

