
	function validateForm(formName) {
		if (formName){
			var valid = true;
			$('#' + formName + ' :input.emkt-required').each(function(index){
				var that = $(this);
				if (that.val() || (that.attr('type') != 'hidden' && that.parent(':hidden').size() > 0)){
					if (!that.hasClass('time_input')){
						markError(that, false);
					}
				}else{
					markError(that, true);
					valid = false;
				}
			});
			if (!valid){
				messages.error(LOCALE.FORM.CHECK.ALL_FIELDS);
				return false;
			}
			$('#' + formName + ' .date_input').each(function(index){
				var that = $(this);
				if (that.val() && that.val() !== ''){
					if (!validateDate(that)){
						valid = false;
						return;
					}
				}
			});
			if (!valid){
				messages.error(LOCALE.FORM.CHECK.DATE_FIELD);
				return false;
			}			
			$('#' + formName + ' .numeric_input').each(function(index){
				var that = $(this);
				if (that.val() && that.val() !== ''){
					if (!validateNumeric(that)){
						valid = false;
						return;
					}
				}
			});
			if (!valid){
				messages.error(LOCALE.FORM.CHECK.NUMERIC_FIELD);
				return false;
			}			
			$('#' + formName + ' .time_input').each(function(index){
				var that = $(this);
				if (that.val() && that.val() !== ''){
					if (!validateTime(that)){
						valid = false;
						return;
					}
				}
			});
			return valid;
		}else{
			return true;
		}
	}



	function markError(field, error){
		if (error){
			field.parent().parent().addClass('error');
		}else{
			field.parent().parent().removeClass('error');
		}
	}


	function validateNumeric(field) {
		var error = false;
		if (field.val() !== '') {
			error = !/^\d+(?:\.\d{1,2})?$/.test(field.val());
			if (error){
				messages.error(LOCALE.FORM.CHECK.NUMERIC_FIELD);
			}else{
				messages.hide();
			}
		}
		markError(field, error);
		return !error;
	}


	function validateDate(field) {
		var error = false;
		if (field.val() !== '') {
			error = !/^\d{1,2}-\d{1,2}-\d{4}$/.test(field.val());
			if (error){
				messages.error(LOCALE.FORM.CHECK.DATE_FIELD);
			}else{
				var day = field.val().substring(0,2)*1;
				var month = field.val().substring(3,5)*1;
				var year = field.val().substring(6,10)*1;
				var fail=false;
				if (month == 2) {
			        if (day == 29) {
			            if (year % 4 != 0 || year % 100 == 0 && year % 400 != 0) {
			            	fail=true;
			            }
			        }
			        else if (day > 28) {
			            fail=true;
			        }
			    }
			    else if (month == 4 || month == 6 || month  == 9 || month == 11) {
			        if (day > 30) {
			            fail=true;
			        }
			    }
			    else {
			        if (day > 31) {
			            fail=true;
			        }
			    }
			    
				if (fail){
					error=true;
					messages.error(LOCALE.FORM.CHECK.DATE_FIELD);
				}else{
					messages.hide();
				}
			}
		}
		markError(field, error);
		return !error;
	}
	
	



	function validateTime(field) {
		var error = false;
		if (field.val() !== '') {
			error = !/^([01]\d|2[0-3]):([0-5]\d):([0-5]\d)$/.test(field.val());
			if (error){
				messages.error(LOCALE.FORM.CHECK.TIME_FIELD);
			}else{
				messages.hide();
			}
		}
		markError(field, error);
		return !error;
	}



	function clearForm(formName) {
		if (formName){
			$('#' + formName).find(':input').each(function() {
				$(this).val('');
			});
		}
	}



	function prepareLinkedField(theId, theLinkedFieldId, theValue) {
		var linkedField = $('#' + theLinkedFieldId);
		if (linkedField){
			linkedField.val(theValue);
			var field = $('#' + theId);
			field.change(function(){
				linkedField.val($(this).val());
			});
			field.change();
		}
	}



	function prepareDateField(theId) {
		var date = $('#' + theId + '-date');
		var time = $('#' + theId + '-time');	
		
		var datetime = $('#' + theId);
		date.change(function(){
			if (validateDate(date)) {
				if (date.val() !== '') {
					//if (time.val() === '') {
						var fecha=new Date();
						var hora=fecha.getHours();
						var minutos=fecha.getMinutes();
						var segundos=fecha.getSeconds();
						if (hora<=9) hora = "0" + hora;
						if (minutos<=9) minutos = "0" + minutos;
						if (segundos<=9) segundos = "0" + segundos;
						var timeStr = hora + ":" + minutos + ":" + segundos;
						time.val(timeStr);
					//}
					datetime.val(date.val() + ' ' + time.val());
				}else{
					datetime.val('');
				}
			}else{
				datetime.val('');
			}
		});
		time.change(function(){
			if (validateTime(time)) {
				if (date.val() !== '') {
					if (time.val() === '') {
						var fecha=new Date();
						var hora=fecha.getHours();
						var minutos=fecha.getMinutes();
						var segundos=fecha.getSeconds();
						if (hora<=9) hora = "0" + hora;
						if (minutos<=9) minutos = "0" + minutos;
						if (segundos<=9) segundos = "0" + segundos;
						var timeStr = hora + ":" + minutos + ":" + segundos;
						time.val(timeStr);
					}
					datetime.val(date.val() + ' ' + time.val());
				}
			}else{
				datetime.val('');
			}
		});    				
	}
