-- --------------------------------------------------------
-- Host:                         127.0.0.1
-- Server version:               5.5.22 - MySQL Community Server (GPL)
-- Server OS:                    Win64
-- HeidiSQL version:             7.0.0.4053
-- Date/time:                    2012-12-16 19:56:26
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET FOREIGN_KEY_CHECKS=0 */;

-- Dumping database structure for tfc-project
DROP DATABASE IF EXISTS `tfc-project`;
CREATE DATABASE IF NOT EXISTS `tfc-project` /*!40100 DEFAULT CHARACTER SET latin1 */;
USE `tfc-project`;


-- Dumping structure for table tfc-project.tb_asseguradora
DROP TABLE IF EXISTS `tb_asseguradora`;
CREATE TABLE IF NOT EXISTS `tb_asseguradora` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `NOM` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `DESCRIPCIO` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `ACTIVA` tinyint(4) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=latin1;

-- Dumping data for table tfc-project.tb_asseguradora: ~2 rows (approximately)
DELETE FROM `tb_asseguradora`;
/*!40000 ALTER TABLE `tb_asseguradora` DISABLE KEYS */;
INSERT INTO `tb_asseguradora` (`ID`, `NOM`, `DESCRIPCIO`, `ACTIVA`) VALUES
	(1, 'Catalana Occidente', 'Catalana Occidente', 1),
	(2, 'Mutua Madrileña', 'Mutua Madrileña', 1);
/*!40000 ALTER TABLE `tb_asseguradora` ENABLE KEYS */;


-- Dumping structure for table tfc-project.tb_client
DROP TABLE IF EXISTS `tb_client`;
CREATE TABLE IF NOT EXISTS `tb_client` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `DNI` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `NOM` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `PRIMER_COGNOM` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `SEGON_COGNOM` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `TELEFON` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `MAIL` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `DATA_NAIXEMENT` varchar(255) NOT NULL,
  `ACTIU` tinyint(4) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;

-- Dumping data for table tfc-project.tb_client: ~1 rows (approximately)
DELETE FROM `tb_client`;
/*!40000 ALTER TABLE `tb_client` DISABLE KEYS */;
INSERT INTO `tb_client` (`ID`, `DNI`, `NOM`, `PRIMER_COGNOM`, `SEGON_COGNOM`, `TELEFON`, `MAIL`, `DATA_NAIXEMENT`, `ACTIU`) VALUES
	(1, '53065259G', 'Isabel', 'Lobato', 'Fernández', '9338885500', 'isabel.lobato@gmail.com', '14-12-2012', 1);
/*!40000 ALTER TABLE `tb_client` ENABLE KEYS */;


-- Dumping structure for table tfc-project.tb_factura
DROP TABLE IF EXISTS `tb_factura`;
CREATE TABLE IF NOT EXISTS `tb_factura` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `CODI_FACTURA` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `DATA_EMISSIO` varchar(255) NOT NULL,
  `PART_DE_LA_FACTURA_FK` bigint(20) NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `TB_FACTURA_PART_DE_LA_FACTURAC` (`PART_DE_LA_FACTURA_FK`),
  CONSTRAINT `TB_FACTURA_PART_DE_LA_FACTURAC` FOREIGN KEY (`PART_DE_LA_FACTURA_FK`) REFERENCES `tb_part` (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

-- Dumping data for table tfc-project.tb_factura: ~0 rows (approximately)
DELETE FROM `tb_factura`;
/*!40000 ALTER TABLE `tb_factura` DISABLE KEYS */;
/*!40000 ALTER TABLE `tb_factura` ENABLE KEYS */;


-- Dumping structure for table tfc-project.tb_operation
DROP TABLE IF EXISTS `tb_operation`;
CREATE TABLE IF NOT EXISTS `tb_operation` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `NAME` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `DESCRIPTION` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `URL` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `PARENT` int(11) NOT NULL,
  `ORDRE` int(11) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=latin1;

-- Dumping data for table tfc-project.tb_operation: ~8 rows (approximately)
DELETE FROM `tb_operation`;
/*!40000 ALTER TABLE `tb_operation` DISABLE KEYS */;
INSERT INTO `tb_operation` (`ID`, `NAME`, `DESCRIPTION`, `URL`, `PARENT`, `ORDRE`) VALUES
	(1, 'cu.menu.usuaris', 'Menu usuaris', '', 0, 1),
	(2, 'cu.menu.usuaris.cerca', 'Cerca usuaris', '/CUGestioUsuaris/CUGestioUsuaris.do', 1, 1),
	(3, 'cu.menu.mestres', 'Gestio mestres', '', 0, 2),
	(4, 'cu.menu.mestres.asseguradores', 'Asseguradores', '/CUCercaAsseguradora/CUCercaAsseguradora.do', 3, 1),
	(5, 'cu.menu.mestres.tipusSinistre', 'Tipus Sinistre', '/CUCercaTipusSinistre/CUCercaTipusSinistre.do', 3, 2),
	(6, 'cu.menu.clients', 'Clients', '', 0, 3),
	(7, 'cu.menu.clients.clients', 'Cerca de clients', '/CUCercaClient/CUCercaClient.do', 6, 1),
	(8, 'cu.menu.clients.parts', 'Cerca de parts', '/CUCercaParts/CUCercaParts.do', 6, 2);
/*!40000 ALTER TABLE `tb_operation` ENABLE KEYS */;


-- Dumping structure for table tfc-project.tb_operations_role
DROP TABLE IF EXISTS `tb_operations_role`;
CREATE TABLE IF NOT EXISTS `tb_operations_role` (
  `OPERATIONS_FK` bigint(20) NOT NULL,
  `ROLES_FK` bigint(20) NOT NULL,
  PRIMARY KEY (`OPERATIONS_FK`,`ROLES_FK`),
  KEY `TB_OPERATION_ROLES_FKC` (`ROLES_FK`),
  KEY `TB_ROLE_OPERATIONS_FKC` (`OPERATIONS_FK`),
  CONSTRAINT `TB_OPERATION_ROLES_FKC` FOREIGN KEY (`ROLES_FK`) REFERENCES `tb_role` (`ID`),
  CONSTRAINT `TB_ROLE_OPERATIONS_FKC` FOREIGN KEY (`OPERATIONS_FK`) REFERENCES `tb_operation` (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- Dumping data for table tfc-project.tb_operations_role: ~10 rows (approximately)
DELETE FROM `tb_operations_role`;
/*!40000 ALTER TABLE `tb_operations_role` DISABLE KEYS */;
INSERT INTO `tb_operations_role` (`OPERATIONS_FK`, `ROLES_FK`) VALUES
	(1, 1),
	(2, 1),
	(3, 2),
	(4, 2),
	(5, 2),
	(6, 2),
	(7, 2),
	(8, 2),
	(6, 3),
	(8, 3);
/*!40000 ALTER TABLE `tb_operations_role` ENABLE KEYS */;


-- Dumping structure for table tfc-project.tb_part
DROP TABLE IF EXISTS `tb_part`;
CREATE TABLE IF NOT EXISTS `tb_part` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `CODI_PART` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `POLISSA` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `DATA_SINISTRE` varchar(255) NOT NULL,
  `BASE_IMPOSABLE` double NOT NULL,
  `PERCENTATGE_IVA` double NOT NULL,
  `OBSERVACIONS` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `OBERT` tinyint(4) NOT NULL,
  `TIPUS_SINISTRE_FK` bigint(20) NOT NULL,
  `CLIENT_FK` bigint(20) NOT NULL,
  `ASSEGURADORA_FK` bigint(20) NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `TB_PART_CLIENT_FKC` (`CLIENT_FK`),
  KEY `TB_PART_TIPUS_SINISTRE_FKC` (`TIPUS_SINISTRE_FK`),
  KEY `TB_PART_ASSEGURADORA_FKC` (`ASSEGURADORA_FK`),
  CONSTRAINT `TB_PART_ASSEGURADORA_FKC` FOREIGN KEY (`ASSEGURADORA_FK`) REFERENCES `tb_asseguradora` (`ID`),
  CONSTRAINT `TB_PART_CLIENT_FKC` FOREIGN KEY (`CLIENT_FK`) REFERENCES `tb_client` (`ID`),
  CONSTRAINT `TB_PART_TIPUS_SINISTRE_FKC` FOREIGN KEY (`TIPUS_SINISTRE_FK`) REFERENCES `tb_tipus_sinistre` (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;

-- Dumping data for table tfc-project.tb_part: ~1 rows (approximately)
DELETE FROM `tb_part`;
/*!40000 ALTER TABLE `tb_part` DISABLE KEYS */;
INSERT INTO `tb_part` (`ID`, `CODI_PART`, `POLISSA`, `DATA_SINISTRE`, `BASE_IMPOSABLE`, `PERCENTATGE_IVA`, `OBSERVACIONS`, `OBERT`, `TIPUS_SINISTRE_FK`, `CLIENT_FK`, `ASSEGURADORA_FK`) VALUES
	(1, 'P-1355505139247', '123', '29-02-2012', 4567.98, 21, 'aaaop', 1, 1, 1, 2);
/*!40000 ALTER TABLE `tb_part` ENABLE KEYS */;


-- Dumping structure for table tfc-project.tb_role
DROP TABLE IF EXISTS `tb_role`;
CREATE TABLE IF NOT EXISTS `tb_role` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `ROLE_ID` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `DESCRIPTION` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;

-- Dumping data for table tfc-project.tb_role: ~3 rows (approximately)
DELETE FROM `tb_role`;
/*!40000 ALTER TABLE `tb_role` DISABLE KEYS */;
INSERT INTO `tb_role` (`ID`, `ROLE_ID`, `DESCRIPTION`) VALUES
	(1, 'ROLE_ADMIN', 'ROLE_ADMIN'),
	(2, 'ROLE_PERIT', 'ROLE_PERIT'),
	(3, 'ROLE_FACTURACIO', 'ROLE_FACTURACIO');
/*!40000 ALTER TABLE `tb_role` ENABLE KEYS */;


-- Dumping structure for table tfc-project.tb_tipus_sinistre
DROP TABLE IF EXISTS `tb_tipus_sinistre`;
CREATE TABLE IF NOT EXISTS `tb_tipus_sinistre` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `NOM` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `ACTIU` tinyint(4) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

-- Dumping data for table tfc-project.tb_tipus_sinistre: ~2 rows (approximately)
DELETE FROM `tb_tipus_sinistre`;
/*!40000 ALTER TABLE `tb_tipus_sinistre` DISABLE KEYS */;
INSERT INTO `tb_tipus_sinistre` (`ID`, `NOM`, `ACTIU`) VALUES
	(1, 'Incendi', 1),
	(2, 'Inundacions', 0);
/*!40000 ALTER TABLE `tb_tipus_sinistre` ENABLE KEYS */;


-- Dumping structure for table tfc-project.tb_user
DROP TABLE IF EXISTS `tb_user`;
CREATE TABLE IF NOT EXISTS `tb_user` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `USER_ID` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `PASSWORD` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `ADRESS` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `ACTIVE` tinyint(4) NOT NULL,
  `NOM` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `PRIMER_COGNOM` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `SEGON_COGNOM` varchar(255) CHARACTER SET latin1 COLLATE latin1_bin NOT NULL,
  `ROL_FK` bigint(20) NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `TB_USER_ROL_FKC` (`ROL_FK`),
  CONSTRAINT `TB_USER_ROL_FKC` FOREIGN KEY (`ROL_FK`) REFERENCES `tb_role` (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;

-- Dumping data for table tfc-project.tb_user: ~3 rows (approximately)
DELETE FROM `tb_user`;
/*!40000 ALTER TABLE `tb_user` DISABLE KEYS */;
INSERT INTO `tb_user` (`ID`, `USER_ID`, `PASSWORD`, `ADRESS`, `ACTIVE`, `NOM`, `PRIMER_COGNOM`, `SEGON_COGNOM`, `ROL_FK`) VALUES
	(1, 'admin', 'admin', 'admin@indra.es', 1, 'Juan Luis', 'Chavez', 'Lobato', 1),
	(2, 'perit', 'perit', 'perit@uoc.edu', 1, 'Peritador', 'Genèric', 'UOC', 2),
	(3, 'factu', 'factu', 'factu@uoc.edu', 1, 'Facturador', 'Genèric', 'UOC', 3);
/*!40000 ALTER TABLE `tb_user` ENABLE KEYS */;
/*!40014 SET FOREIGN_KEY_CHECKS=1 */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
